/************************************************************
** 文件名：BasicTypes.h
** Copyright (c) 2017-2019 北京科银京成技术有限公司
** 创建人：陈桐鑫<tomjchan@foxmail.com>
** 日  期：2017-01-10
** 修改人：无
** 日  期：无
** 描  述：BasicTypes头文件
** 版  本：Version 2.1
**----------------------------------------------------------
************************************************************/
#ifndef _GLOBAL_BASICTYPES_H_INCLUDED_
#define _GLOBAL_BASICTYPES_H_INCLUDED_

//#include "ReturnCode.h"
#include <vector>
#include <list>
#include <map>
#include <utility>
#include <string>
#include <queue>
using std::vector;
using std::list;
using std::map;
using std::pair;
using std::string;
using std::make_pair;
using std::queue;

//test
#include <iostream>

using std::cout;
using std::endl;
using std::string;

#ifdef WIN32 //移植
#define _WIN32_WINNT   0x0501
#include <winsock.h>
#endif

#ifdef KYLIN
#include <semaphore.h>
#include <string.h>
#include <stdint.h>
#define FALSE false
#define TRUE true
#endif


//大数据
#include <math.h>

/**
* @ brief 定义GUID前缀
*/
typedef unsigned char Octet;
typedef Octet _GUID_PREFIX_T[12];
const _GUID_PREFIX_T GUIDPREFIX_UNKNOWN = {\
    0x00, 0x00, 0x00, 0x00, \
    0x00, 0x00, 0x00, 0x00, \
    0x00, 0x00, 0x00, 0x00};

/**
* @ brief 定义EntityId
*/
typedef Octet _ENTITY_KEY_TYPE[3];
typedef Octet _ENTITY_KIND_T;
struct _ENTITY_ID_T 
{
    _ENTITY_KEY_TYPE EntityKey;
    _ENTITY_KIND_T EntityKind;

    //重载运算符 =
    _ENTITY_ID_T operator = (const _ENTITY_ID_T &Right) 
    {
        memcpy(&this->EntityKey, &Right.EntityKey, sizeof(_ENTITY_KEY_TYPE));
        memcpy(&this->EntityKind, &Right.EntityKind, sizeof(_ENTITY_KIND_T));

        return *this;
    }

    //重载运算符 <
    bool operator < (const _ENTITY_ID_T &Right) const 
    {
        for (int I = 0; I < 3; ++I) 
        {
            if (this->EntityKey[I] < Right.EntityKey[I]) 
            {
                return true;
            }
            else if (this->EntityKey[I] > Right.EntityKey[I]) 
            {
                return false;
            }
        }
        if (this->EntityKind < Right.EntityKind) 
        {
            return true;
        }
        return false;
    }

    //重载运算符 >
    bool operator > (const _ENTITY_ID_T &Right) const 
    {
        for (int I = 0; I < 3; ++I) 
        {
            if (this->EntityKey[I] > Right.EntityKey[I]) 
            {
                return true;
            }
            else if (this->EntityKey[I] < Right.EntityKey[I]) 
            {
                return false;
            }
        }
        if (this->EntityKind > Right.EntityKind) 
        {
            return true;
        }
        return false;
    }

    //重载运算符 >=
    bool operator >= (const _ENTITY_ID_T &Right) const 
    {
        for (int I = 0; I < 3; ++I) 
        {
            if (this->EntityKey[I] > Right.EntityKey[I]) 
            {
                return true;
            }
            else if (this->EntityKey[I] < Right.EntityKey[I]) 
            {
                return false;
            }
        }
        if (this->EntityKind >= Right.EntityKind) 
        {
            return true;
        }
        return false;
    }

    //重载运算符 <=
    bool operator <= (const _ENTITY_ID_T &Right) const 
    {
        for (int I = 0; I < 3; ++I) 
        {
            if (this->EntityKey[I] < Right.EntityKey[I]) 
            {
                return true;
            }
            else if (this->EntityKey[I] > Right.EntityKey[I]) 
            {
                return false;
            }
        }
        if (this->EntityKind <= Right.EntityKind) 
        {
            return true;
        }
        return false;
    }

    //重载运算符 ==
    bool operator == ( const _ENTITY_ID_T &Right)
    {
        int N = 0;
        while( N < 3)
        {
            if( this->EntityKey[N] != Right.EntityKey[N])
                return false;
            ++N;
        }
        if( this->EntityKind != Right.EntityKind)
            return false;

        return true;
    }

    //重载运算符 !=
    bool operator != ( const _ENTITY_ID_T &Right)
    {
        int N = 0;
        while( N < 3)
        {
            if( this->EntityKey[ N] != Right.EntityKey[ N])
                return true;
            ++N;
        }
        if( this->EntityKind != Right.EntityKind)
            return true;

        return false;
    }

};
//#define ENTITYID_UNKNOW { 0x00, 0x00, 0x00, 0x00}
//OMG规范定义的EntityKind
//未知实体
#define ENTITYKIND_USER_UNKNOWN             0x00
//内置未知端点
#define ENTITYKIND_BUILTIN_UNKNOWN          0xc0
//内置域参与者端点
#define ENTITYKIND_BUILTIN_PARTICIPANT      0xc1
//用户带key发布端
#define ENTITYKIND_USER_WRITER_WITH_KEY     0x02
//内置带key发布端
#define ENTITYKIND_BUILTIN_WRITER_WITH_KEY  0xc2
//用户发布端
#define ENTITYKIND_USER_WRITER_NO_KEY       0x03
//内置发布端
#define ENTITYKIND_BUILTIN_WRITER_NO_KEY    0xc3
//用户带key订阅端
#define ENTITYKIND_USER_READER_WITH_KEY     0x07
//内置带key订阅端
#define ENTITYKIND_BUILTIN_READER_WITH_KEY  0xc7
//用户订阅端
#define ENTITYKIND_USER_READER_NO_KEY       0x04
//内置订阅端
#define ENTITYKIND_BUILTIN_READER_NO_KEY    0xc4

//定义内置对象的EntityId
//未知实体EntityId
const _ENTITY_ID_T ENTITYID_UNKNOW                                    = {{ 0x00, 0x00, 0x00}, 0x00 };
//域参与者EntityId
const _ENTITY_ID_T ENTITYID_PARTICIPANT                               = { {0x00, 0x00, 0x01}, 0xc1 };
//内置主题发布端EntityId
const _ENTITY_ID_T ENTITYID_SEDP_BUILTIN_TOPIC_WRITER                 = { {0x00, 0x00, 0x02}, 0xc2 };
//内置主题订阅端EntityId
const _ENTITY_ID_T ENTITYID_SEDP_BUILTIN_TOPIC_READER                 = { {0x00, 0x00, 0x02}, 0xc7 };
//内置发布信息发布端EntityId
const _ENTITY_ID_T ENTITYID_SEDP_BUILTIN_PUBLICATIONS_WRITER          = { {0x00, 0x00, 0x03}, 0xc2 };
//内置发布定西订阅端EntityId
const _ENTITY_ID_T ENTITYID_SEDP_BUILTIN_PUBLICATIONS_READER          = {{ 0x00, 0x00, 0x03}, 0xc7 };
//内置订阅信息发布端EntityId
const _ENTITY_ID_T ENTITYID_SEDP_BUILTIN_SUBSCRIPTIONS_WRITER         = { {0x00, 0x00, 0x04}, 0xc2 };
//内置订阅信息订阅端EntityId
const _ENTITY_ID_T ENTITYID_SEDP_BUILTIN_SUBSCRIPTIONS_READER         = {{ 0x00, 0x00, 0x04}, 0xc7 };
//内置域参与者发布端EntityId
const _ENTITY_ID_T ENTITYID_SPDP_BUILTIN_PARTICIPANT_WRITER           = { {0x00, 0x01, 0x00}, 0xc2 };
//内置域参与者订阅端EntityId
const _ENTITY_ID_T ENTITYID_SPDP_BUILTIN_PARTICIPANT_READER           = { {0x00, 0x01, 0x00}, 0xc7 };
//内置域参与者信息发布端EntityId
const _ENTITY_ID_T ENTITYID_P2P_BUILTIN_PARTICIPANT_MESSAGE_WRITER    = { {0x00, 0x02, 0x00}, 0xc2 };
//内置域参与者信息订阅端EntityId
const _ENTITY_ID_T ENTITYID_P2P_BUILTIN_PARTICIPANT_MESSAGE_READER    = { {0x00, 0x02, 0x00}, 0xc7 };

/**
* @ brief 定义GUID
*/
struct _GUID_T 
{
    _GUID_PREFIX_T GuidPrefix;
    _ENTITY_ID_T EntityId;

    _GUID_T () {};
    _GUID_T(_GUID_PREFIX_T Prefix, _ENTITY_ID_T Id) 
    {
        memcpy (this->GuidPrefix, Prefix, sizeof(_GUID_PREFIX_T));
        this->EntityId = Id;
    }

    //重载运算符==
    bool operator ==( const _GUID_T &Right) 
    {
        int M = 0;
        while ( M < 12)
        {
            if( this->GuidPrefix[M] != Right.GuidPrefix[M])
                return false;
            ++M;
        }
        if( this->EntityId != Right.EntityId)
            return false;

        return true;
    }

    //重载运算符 !=
    bool operator != ( const _GUID_T &Right)
    {
        int M = 0;
        while ( M < 12)
        {
            if( this->GuidPrefix[M] != Right.GuidPrefix[M])
                return true;
            ++M;
        }
        if( this->EntityId != Right.EntityId)
            return true;

        return false;
    }

    //重载运算符 <
    bool operator < ( const _GUID_T &Right) const 
    {
        int M = 0;
        while (M < 12)
        {
            if(this->GuidPrefix[M] > Right.GuidPrefix[M]) 
            {
                return false;
            }
            else if (this->GuidPrefix[M] < Right.GuidPrefix[M]) 
            {
                return true;
            }
            ++M;
        }
        if( this->EntityId < Right.EntityId)
            return true;

        return false;
    }

    //重载运算符 >
    bool operator > ( const _GUID_T &Right) const
    {
        int M = 0;
        while (M < 12)
        {
            if(this->GuidPrefix[M] < Right.GuidPrefix[M])
            {
                return false;
            }
            else if (this->GuidPrefix[M] > Right.GuidPrefix[M]) 
            {
                return true;
            }
            ++M;
        }
        if( this->EntityId > Right.EntityId)
            return true;
		
        return false;
    }

    //重载运算符 =
    _GUID_T operator = ( const _GUID_T &Right)
    {
        memcpy (this->GuidPrefix, Right.GuidPrefix, sizeof(_GUID_PREFIX_T));
        this->EntityId = Right.EntityId;

        return *this;
    }
};

//#define GUID_UNKNOWN { GUIDPREFIX_UNKNOWN, ENTITYID_UNKNOW }
const _GUID_T GUID_UNKNOWN((Octet*)GUIDPREFIX_UNKNOWN, ENTITYID_UNKNOW);

/**
* @ brief 定义时间格式_TIME_T
*/
struct _TIME_T 
{
    int lSecond;
    unsigned int ulNanosec;
    //重载运算符 <=
    bool operator <= (const _TIME_T &Right) const 
    {
        if (this->lSecond > Right.lSecond) 
        {
            return false;
        }
        else if (this->lSecond < Right.lSecond) 
        {
            return true;
        }
        else if (this->ulNanosec > Right.ulNanosec) 
        {
            return false;
        }
        else 
        {
            return true;
        }
    }

    //重载运算符 <
    bool operator < (const _TIME_T &Right) const 
    {
        if (this->lSecond > Right.lSecond) 
        {
            return false;
        }
        else if (this->lSecond < Right.lSecond) 
        {
            return true;
        }
        else if (this->ulNanosec >= Right.ulNanosec) 
        {
            return false;
        }
        else 
        {
            return true;
        }
    }

    //重载运算符 >=
    bool operator >= (const _TIME_T &Right) const 
    {
        if (this->lSecond < Right.lSecond) 
        {
            return false;
        }
        else if (this->lSecond > Right.lSecond) 
        {
            return true;
        }
        else if (this->ulNanosec < Right.ulNanosec) 
        {
            return false;
        }
        else 
        {
            return true;
        }
    }

    //重载运算符 >
    bool operator > (const _TIME_T &Right) const 
    {
        if (this->lSecond < Right.lSecond) 
        {
            return false;
        }
        else if (this->lSecond > Right.lSecond) 
        {
            return true;
        }
        else if (this->ulNanosec <= Right.ulNanosec) 
        {
            return false;
        }
        else 
        {
            return true;
        }
    }

    //重载运算符 ==
    bool operator == (const _TIME_T &Right) const 
    {
        if (this->lSecond == Right.lSecond &&
            this->ulNanosec == Right.ulNanosec) 
        {
            return true;
        }
        else 
        {
            return false;
        }
    }

    //重载运算符 !=
    bool operator != (const _TIME_T &Right) const 
    {
        if (this->lSecond == Right.lSecond &&
            this->ulNanosec == Right.ulNanosec) 
        {
                return false;
        }
        else 
        {
            return true;
        }
    }



	//修改2018-8-1
	//重载运算符 +
    _TIME_T operator + (const _TIME_T &Right) const 
    {
        _TIME_T Temp = *this;
        if (Right.ulNanosec + Temp.ulNanosec >= 1000000000) 
        {
            ++ Temp.lSecond;
			Temp.ulNanosec = Temp.ulNanosec+Right.ulNanosec-1000000000;
        }
		else
			Temp.ulNanosec = Temp.ulNanosec+Right.ulNanosec;
        
        Temp.lSecond += Right.lSecond;

        return Temp;
    }

    //重载运算符 -
    _TIME_T operator - (const _TIME_T &Right) const 
    {
        _TIME_T Temp = *this;
        //if (Temp.ulNanosec - Right.ulNanosec < 0)
		if (Temp.ulNanosec < Right.ulNanosec)
		{
		   --Temp.lSecond;
			Temp.ulNanosec = Temp.ulNanosec+1000000000-Right.ulNanosec;
		}
		else
		{
			Temp.ulNanosec -= Right.ulNanosec;
		}

        Temp.lSecond -= Right.lSecond;

        return Temp;
	}

		//大数据，重载运算符/
	_TIME_T operator / (const double &Right) const 
    {
        _TIME_T Temp = *this;
		double dTempb = Temp.lSecond + Temp.ulNanosec / 1000000000.0;
        double dTempa = dTempb/Right;
        Temp.lSecond = floor(dTempa);
		Temp.ulNanosec = (dTempa - floor(dTempa))*1000000000;
        return Temp;
    }
	std::string time_to_string()
	{
		time_t t = time(0);
		char tmpBuf[100];
		strftime(tmpBuf, 100, "%Y-%m-%d %H:%M:%S", localtime(&t));
		return tmpBuf;
	}

	unsigned long long time_to_number()
	{
		return ((unsigned long long)lSecond * 1000 + (unsigned long long)ulNanosec / 1000000);
	}
};

//时间信息
typedef _TIME_T _DURATION_T;

//时间0
const _TIME_T TIME_ZERO      = { 0, 0 };
//非法时间
const _TIME_T TIME_INVALID   = { -1, 0xffffffff };
//最大时间
const _TIME_T TIME_INFINITE  = { 0x7fffffff, 0xffffffff };

const _TIME_T TIME_ONE_MINUTE   = { 60, 0 };

const _TIME_T TIME_TWO_SECONDS = {2,0};

//回复心跳信息的延时
const _DURATION_T HEARTBEAT_RESPONSE_DELAY       = { 0, /*测试徐森500000000*/100000000 };
//心跳信息忽略时间
const _DURATION_T HEARTBEAT_SUPPRESSION_DURATION = { 0, 0 };
//心跳信息重发时间
const _DURATION_T HEARTBEAT_PERIOD               = { 0,  /*测试徐森400000000*/100000000 };
//nack信息回复延时
const _DURATION_T NACK_RESPONSE_DELAY            = { 0,  /*测试徐森200000000*/50000000 };
//nack信息忽略时间
const _DURATION_T NACK_SUPPRESSION_DURATION      = { 0, 0 };

/**
* @ brief 定义供应商编号
*/
struct _VENDOR_ID_T 
{
    Octet VendorId[2];

    _VENDOR_ID_T operator = (const _VENDOR_ID_T &Right) 
    {
        memcpy(this->VendorId, Right.VendorId, sizeof(_VENDOR_ID_T));

        return *this;
    }
};
const _VENDOR_ID_T VENDORID_UNKNOWN  = { {0x00, 0x00} };
const _VENDOR_ID_T VENDORID_SEU      = { {0x08, 0x08 }};

/**
* @ brief 定义数据的序列号 64bit
* @       重载部分运算符
*/
struct _SEQUENCE_NUMBER_T 
{
    int lHigh;
    unsigned int ulLow;

    //默认构造函数 赋值为-1 表示错误的序列号
    _SEQUENCE_NUMBER_T () 
    {
        this->lHigh = -2;
        this->ulLow = 0;
    }

    //构造函数
    _SEQUENCE_NUMBER_T (const int lSeqhigh, const unsigned int ulSeqlow)
    {
        this->lHigh = lSeqhigh;
        this->ulLow = ulSeqlow;
    }

    //赋值方法 ()
    _SEQUENCE_NUMBER_T operator () (const int lSeqhigh, const unsigned int ulSeqlow)
    {
        this->lHigh = lSeqhigh;
        this->ulLow = ulSeqlow;

        return *this;
    }

    //重载运算符 <
    bool operator < (const _SEQUENCE_NUMBER_T &Right) const 
    {
        if (this->lHigh < Right.lHigh) 
        {
            return true;
        }
        else if (this->lHigh > Right.lHigh) 
        {
            return false;
        }
        else if (this->ulLow < Right.ulLow) 
        {
            return true;
        }
        else 
        {
            return false;
        }
    }

    //重载运算符 <=
    bool operator <= (const _SEQUENCE_NUMBER_T &Right) const 
    {
        if (this->lHigh < Right.lHigh) 
        {
            return true;
        }
        else if (this->lHigh > Right.lHigh) 
        {
            return false;
        }
        else if (this->ulLow <= Right.ulLow) 
        {
            return true;
        }
        else 
        {
            return false;
        }
    }

    //重载运算符 >
    bool operator > (const _SEQUENCE_NUMBER_T &Right) const 
    {
        if (this->lHigh > Right.lHigh) 
        {
            return true;
        }
        else if (this->lHigh < Right.lHigh) 
        {
            return false;
        }
        else if (this->ulLow > Right.ulLow) 
        {
            return true;
        }
        else 
        {
            return false;
        }
    }

    //重载运算符 >
    bool operator > (const unsigned int &Right) const
    {
        if (this->lHigh > 0) 
        {
            return true;
        }
        else if (this->lHigh < 0) 
        {
            return false;
        }
        else if (this->ulLow > Right) 
        {
            return true;
        }
        else 
        {
            return false;
        }
    }

    //重载运算符 >=
    bool operator >= (const _SEQUENCE_NUMBER_T &Right) const 
    {
        if (this->lHigh > Right.lHigh) 
        {
            return true;
        }
        else if (this->lHigh < Right.lHigh) 
        {
            return false;
        }
        else if (this->ulLow >= Right.ulLow) 
        {
            return true;
        }
        else 
        {
            return false;
        }
    }

    //重载运算符 !=
    bool operator != (const _SEQUENCE_NUMBER_T &Right) const 
    {
        if ((this->lHigh == Right.lHigh) && (this->ulLow == Right.ulLow)) 
        {
            return false;
        }
        else 
        {
            return true;
        }
    }

    //重载运算符 ==
    bool operator == (const _SEQUENCE_NUMBER_T &Right) const 
    {
        if ((this->lHigh == Right.lHigh) && (this->ulLow == Right.ulLow)) 
        {
            return true;
        }
        else 
        {
            return false;
        }
    }

    //重载运算符 =
    _SEQUENCE_NUMBER_T operator = (const _SEQUENCE_NUMBER_T &Right) 
    {
        this->lHigh = Right.lHigh;
        this->ulLow = Right.ulLow;

        return *this;
    }

    //重载运算符 =
    _SEQUENCE_NUMBER_T operator = (const unsigned int &Right)
    {
        this->lHigh = 0;
        this->ulLow = Right;

        return *this;
    }

    //重载运算符 前置++
    _SEQUENCE_NUMBER_T operator ++ () 
    {
        ++ (this->ulLow);
        if (this->ulLow == 0)
        {
            ++ (this->lHigh);
        }

        return *this;
    }

    //重载运算符 后置++
    _SEQUENCE_NUMBER_T operator ++ (int) 
    {
        _SEQUENCE_NUMBER_T Temp;
        Temp.lHigh = this->lHigh;
        Temp.ulLow = this->ulLow;
        this->ulLow ++;
        if (this->ulLow == 0)
        {
            this->lHigh ++;
        }

        return Temp;
    }

    //重载运算符 前置--
    _SEQUENCE_NUMBER_T operator -- () 
    {
        if (this->ulLow == 0) 
        {
            -- (this->lHigh);
        }
        -- (this->ulLow);

        return *this;
    }

    //重载运算符 后置--
    _SEQUENCE_NUMBER_T operator -- (int)
    {
        _SEQUENCE_NUMBER_T Temp;
        Temp.lHigh = this->lHigh;
        Temp.ulLow = this->ulLow;
        if (this->ulLow == 0) 
        {
            -- (this->lHigh);
        }
        -- (this->ulLow);

        return Temp;
    }

    //重载运算符 +
    _SEQUENCE_NUMBER_T operator + (const int Add) const
    {
        _SEQUENCE_NUMBER_T Temp = *this;
        ////cout<<Temp.ulLow<<" "<<Add<<" "<<(unsigned int)-1<<endl;
        if (Temp.ulLow  > (unsigned int)-1 - Add)
        {
            ++ Temp.lHigh;
        }
        Temp.ulLow += Add;

        return Temp;
    }

    //重载运算符 +
    _SEQUENCE_NUMBER_T operator + (const _SEQUENCE_NUMBER_T &Right) const 
    {
        _SEQUENCE_NUMBER_T Temp = *this;
        if (Temp.ulLow  > (unsigned int)-1 - Right.ulLow)
        {
            ++ Temp.lHigh;
        }
        Temp.ulLow += Right.ulLow;
        Temp.lHigh += Right.lHigh;

        return Temp;
    }

    //重载运算符 -
    _SEQUENCE_NUMBER_T operator - (const unsigned int Sub) const
    {
        _SEQUENCE_NUMBER_T Temp = *this;
        if (Temp.ulLow < Sub)
        {
            -- Temp.lHigh;
        }
        Temp.ulLow -= Sub;

        return Temp;
    }

    //重载运算符 -
    _SEQUENCE_NUMBER_T operator - (const _SEQUENCE_NUMBER_T &Right) const 
    {
        _SEQUENCE_NUMBER_T Temp = *this;
        if (Temp.ulLow < Right.ulLow)
        {
            -- Temp.lHigh;
//            Temp.ulLow = Temp.ulLow + 4294967295 - Right.ulLow;
            Temp.ulLow = Temp.ulLow - Right.ulLow;
        }
        else
				Temp.ulLow -= Right.ulLow;

        Temp.lHigh -= Right.lHigh;

        return Temp;
    }

    //重载运算符 +=
    _SEQUENCE_NUMBER_T operator += (const int lAdd)
    {
        if (this->ulLow  > (unsigned int)-1 - lAdd)
        {
            ++ this->lHigh;
        }
        this->ulLow += lAdd;

        return *this;
    }

    //重载运算符 -=
    _SEQUENCE_NUMBER_T operator -= (const int lSub)
    {
        if (this->ulLow - lSub < 0)
        {
            -- this->lHigh;
        }
        this->ulLow -= lSub;

        return *this;
    }
};

//未知序列号
const _SEQUENCE_NUMBER_T SEQUENCENUMBER_UNKNOWN;

//序列号队列
typedef queue<_SEQUENCE_NUMBER_T> _SEQ_NUM_QUEUE;

/**
* @ brief 定义地址格式 ip + ulPort
* @       暂时只考虑ipv4
*/
/*
struct _LOCATOR_T {
long Kind;
unsigned long ulPort;
Octet ulAddress[16];
};
*/
//目前定义为IPv4格式
struct _LOCATOR_T 
{
    //ipv4 "a.b.c.d" => ulAddress = (((a*256 + b)*256 + c)*256 + d
    unsigned int ulAddress;
    unsigned int ulPort;

    //重载运算符 !=
    bool operator != (const _LOCATOR_T &Right) const 
    {
        if (this->ulAddress == Right.ulAddress &&
            this->ulPort == Right.ulPort) 
        {
            return false;
        }
        else 
        {
            return true;
        }
    }

    //重载运算符 ==
    bool operator == (const _LOCATOR_T &Right) 
    {
        if (this->ulAddress == Right.ulAddress &&
            this->ulPort == Right.ulPort) 
        {
            return true;
        }
        else 
        {
            return false;
        }
    }
};
const _LOCATOR_T LOCATOR_INVALID = { 0, 0 };
//定义默认端口Port
#define PORT_BASE_NUMBER 7400
#define DOMAINID_GAIN 250
#define PARTICIPANTID_GAIN 2
#define ADDITIONAL_OFFSETS_D0 0
#define ADDITIONAL_OFFSETS_D1 10
#define ADDITIONAL_OFFSETS_D2 1
#define ADDITIONAL_OFFSETS_D3 11
//多播端口
#define SPDP_WELL_KNOWN_MULTICAST_PORT(ulDomainId) \
    PORT_BASE_NUMBER + DOMAINID_GAIN * (unsigned long)ulDomainId + ADDITIONAL_OFFSETS_D0
//单播端口
#define SPDP_WELL_KNOWN_UNICAST_PORT(ulDomainId, ulParticipantId) \
    PORT_BASE_NUMBER + DOMAINID_GAIN * (unsigned long)ulDomainId + ADDITIONAL_OFFSETS_D1 + \
    PARTICIPANTID_GAIN * (unsigned long)ulParticipantId
//用户多播端口
#define USER_DEFAULT_MULTICAST_PORT(ulDomainId) \
    PORT_BASE_NUMBER + DOMAINID_GAIN * (unsigned long)ulDomainId + ADDITIONAL_OFFSETS_D2
//用户单播端口
#define USER_DEFAULT_UNICAST_PORT(ulDomainId, ulParticipantId) \
    PORT_BASE_NUMBER + DOMAINID_GAIN * (unsigned long)ulDomainId + ADDITIONAL_OFFSETS_D3 + \
    PARTICIPANTID_GAIN * (unsigned long)ulParticipantId


/**
* @ brief 定义地址列表
*/
typedef vector<_LOCATOR_T> _LOCATOR_LIST_T;
/*
*Nephalem ParameterID定义
*/
#define PID_PAD								   0x0000
#define PID_SENTINEL						   0x0001
#define PID_PARTICIPANT_LEASE_DURATION		   0x0002
#define PID_PERSISTENCE						   0x0003
#define PID_TIME_BASED_FILTER			  	   0x0004
#define PID_TOPIC_NAME						   0x0005
#define PID_OWNERSHIP_STRENGTH                 0x0006
#define PID_TYPE_NAME                          0x0007
#define PID_METATRAFFIC_MULTICAST_IPADDRESS    0x000d
#define PID_DEFAULT_UNICAST_IPADDRESS	       0x000c
#define PID_DEFAULT_UNICAST_PORT		       0x000e
#define PID_EXPECTS_ACK					       0x0010
#define PID_MULTICAST_IPADDRESS			       0x0011
#define PID_SEND_QUEUE_SIZE                    0x0013
#define PID_PROTOCOL_VERSION		           0x0015
#define PID_VENDOR_ID				           0x0016
#define PID_RECV_QUEUE_SIZE				       0x0018
#define PID_RELIABLITY                         0x001a
#define PID_LIVENESS					       0x001b
#define PID_DURABILITY				    	   0x001d
#define PID_DURABILITY_SERVICE			       0x001e
#define PID_OWNERSHIP					       0x001f
#define PID_PRESENTATION				       0x0021
#define PID_DEADLINE					       0x0023
#define PID_DESTINATION_ORDER                  0x0025
#define PID_LATENCY_BUDGET			    	   0x0027
#define PID_PARTITION				    	   0x0029
#define PID_LIFESPAN			    		   0x002b
#define PID_USER_DATA						   0x002c
#define PID_GROUP_DATA						   0x002d
#define PID_TOPIC_DATA						   0x002e
#define PID_UNICAST_LOCATOR					   0x002f
#define PID_MULTICAST_LOCATOR				   0x0030
#define PID_DEFAULT_UNICAST_LOCATOR			   0x0031
#define PID_METATRAFFIC_UNICAST_LOCATOR		   0x0032
#define PID_METATRAFFIC_MULTICAST_LOCATOR	   0x0033
#define PID_PARTICIPANT_MANUAL_LIVELINESS_COUNT 0x0034
#define PID_CONTENT_FILTER_PROPERTY		       0x0035
#define PID_HISTORY							   0x0040
#define PID_RESOURCE_LIMITS					   0x0041
#define PID_EXPECTS_INLINE_QOS				   0x0043
#define PID_PARTICIPANT_BUILTIN_ENDPOINTS	   0x0044
#define PID_METATRAFFIC_MULTICAST_PORT	       0x0046
#define PID_DEFAULT_MULTICAST_LOCATOR		   0x0048
#define PID_TRANSPORT_PRIORITY			       0x0049
#define PID_PARTICIPANT_GUID			       0x0050
#define PID_PARTICIPANT_ENTITYID			   0x0051
#define PID_GROUP_GUID						   0x0052
#define PID_GROUP_ENTITY_ID					   0x0053
#define PID_ENDPOINT_GUID					   0x005a
#define PID_BUTLTIN_ENDPOINT_SET		       0x0058
#define PID_PROPERTY_LIST					   0x0059
#define PID_TYPE_MAX_SIZE_SERIALIZED		   0x0060
#define PID_ENTITY_NAME						   0x0062
#define PID_KEY_HASH						   0x0070
#define PID_STATUS_INFO					       0x0071
#define PID_TYPE_OBJECT						   0x0072
#define PID_TYPE_CONSISTENCY				   0x0074
#define PID_PRODUCT_VERSION				       0x8000
#define PID_ENTITY_VIRTUAL_GUID				   0x8002
#define PID_SERVICE_KIND					   0x8003
#define PID_TYPE_CODE						   0x8004
#define PID_DISABLE_POSITIVE_ACKS			   0x8005
#define PID_EXPECTS_VIRTUAL_HB				   0x8009
#define PID_ACK_KIND				           0x800b
#define PID_PEER_HOST_EPOCH					   0X800e
#define PID_DOMAIN_ID					       0X800F
#define PID_TRANSPORT_INFO_LIST				   0X8010
#define PID_DIRECT_COMMUNICATION			   0x8011
#define PID_STATUS					           0x1115

#define PEER_HOST_EPOCH						   0x00
/**
* @ brief 定义QoS
*/
//_QOS_POLICY名称，目前为_RELIABILITY_QOS_POLICY和//_DEADLINE_QOS_POLICY
enum _QOS_POLICY_NAME_T 
{
	EXPECTSACKQOSPOLICY        = PID_EXPECTS_ACK,
	USERDATAQOSPOLICY		   = PID_USER_DATA,
	TOPICNAME				   = PID_TOPIC_NAME,
	TYPE_NAME				   = PID_TYPE_NAME,
    GROUPDATAQOSPOLICY		   = PID_GROUP_DATA,
    TOPICDATAQOSPOLICY		   = PID_TOPIC_DATA,
	DURABILITYQOSPOLICY		   = PID_DURABILITY,
	DEADLINEQOSPOLICY		   = PID_DEADLINE,
	LATENCY_BUDGETQOSPOLICY    = PID_LATENCY_BUDGET,
	LIVELINESSQOSPOLICY	       = PID_LIVENESS,
	RELIABILITYQOSPOLICY       = PID_RELIABLITY,
	LIFESPANQOSPOLICY		   = PID_LIFESPAN,
	DESTINATIONORDERQOSPOLICY  = PID_DESTINATION_ORDER,
	HISTORYQOSPOLICY		   = PID_HISTORY,
	RESOURCELIMITSQOSPOLICY    = PID_RESOURCE_LIMITS,
	OWNERSHIPQOSPOLICY		   = PID_OWNERSHIP,
	OWNERSHIPSTRENGTHQOSPOLICY = PID_OWNERSHIP_STRENGTH,
	PRESENTATIONQOSPOLICY	   = PID_PRESENTATION,
	PARTITIONQOSPOLICY		   = PID_PARTITION ,
	TIMEBASEDFILTERQOSPOLICY   = PID_TIME_BASED_FILTER ,
	TRANSPORTPRIORITYQOSPOLICY = PID_TRANSPORT_PRIORITY ,
	DURABILITYSERVICEQOSPOLICY = PID_DURABILITY_SERVICE ,
	ACKKINDQOSPOLICY		   = PID_ACK_KIND,

	MASSDATAQOSPOLICY,
	//MultiNetWorkCard
	MULTINETWORKCARDQOSPOLICY,
	PRIVILAGESTRENGTHQOSPOLICY,
	READERDATALIFECYCLEQOSPOLICY,
	PERIODPUBLICATION,
	TRANSPORT_PRIORITY_QOS_POLICY,
	EMERGENCYQOSPOLICY
};

struct _QOS_POLICY 
{
    _QOS_POLICY_NAME_T Name;
};

typedef int _RELIABILITY_KIND_T;
#define BEST_EFFORT 1
#define RELIABLE 2
#define RELIABLE_UDP 7

struct _RELIABILITY_QOS_POLICY : _QOS_POLICY 
{
	_RELIABILITY_KIND_T Kind;
	_DURATION_T MaxBlockingTime;

	_RELIABILITY_QOS_POLICY()
	{
		this->Name = RELIABILITYQOSPOLICY;
		this->Kind = BEST_EFFORT;
		this->MaxBlockingTime.lSecond = 0;
		this->MaxBlockingTime.ulNanosec = 100000000; //default to 100ms
	}

	_RELIABILITY_QOS_POLICY & operator = (const _RELIABILITY_QOS_POLICY &right)
	{
		this->Kind = right.Kind;
		this->MaxBlockingTime = right.MaxBlockingTime;
		return *this;
	}

    //在同时使用RELIABLE和ResourceLimitsQosPolicy策略时，锁住数据块的最大时间长度,目前设为空值
    //_DURATION_T max_blocking_time;
};

struct _DEADLINE_QOS_POLICY : _QOS_POLICY 
{
    _DEADLINE_QOS_POLICY() 
    {
        this->Name = DEADLINEQOSPOLICY;
        this->Period = TIME_INFINITE;
    }

    _DURATION_T Period;
};

typedef int _DURABILITY_KIND_T;
#define VOLATILE 0
#define TRANSIENT_LOCAL 1
#define TRANSIENT 2
#define PERSISTENT 3
struct _DURABILITY_QOS_POLICY : _QOS_POLICY 
{
    _DURABILITY_QOS_POLICY() 
    {
        this->Name = DURABILITYQOSPOLICY;
        this->Kind = VOLATILE;
    }

    _DURABILITY_KIND_T Kind;
};

typedef int _HISTORY_KIND_T;
#define KEEP_NONE 1
#define KEEP_LAST 2
#define KEEP_ALL 3
struct _HISTORY_QOS_POLICY : _QOS_POLICY 
{
    _HISTORY_QOS_POLICY() 
    {
        this->Name = HISTORYQOSPOLICY;
        this->Kind = KEEP_NONE;
		this->ulDepth = 1;
    }

    _HISTORY_KIND_T Kind;
	unsigned int ulDepth;
};

//大数据
struct _MASS_DATA_QOS_POLICY : _QOS_POLICY
{
    _MASS_DATA_QOS_POLICY() 
    {
        this->Name = MASSDATAQOSPOLICY;
		this->Period = TIME_INVALID;
    }

    _DURATION_T Period;
};

//MultiNetWorkCard
struct _MULTI_NETWORK_CARD_QOS_POLICY : _QOS_POLICY
{
	_MULTI_NETWORK_CARD_QOS_POLICY()
	{
		this->Name = MULTINETWORKCARDQOSPOLICY;
		this->IsMultiNetCard = false;
		this->MultiNetCardNumber = 0;
	}
	bool IsMultiNetCard;
	int MultiNetCardNumber;
};

//重载运算符 ==
//bool _DATA_READER_QOS::operator== (const _DATA_WRITER_QOS& Right) const{
//	if(this->Reliability.Kind != Right.Reliability.Kind)
//		return false;
//	if(this->Deadline.Period < Right.Deadline.Period)
//		return false;
//	if(this->Durability.Kind > Right.Durability.Kind)
//		return false;
//	return true;
//}


//const _DATA_WRITER_QOS *DDS_DATAWRITER_QOS_DEFAULT = NULL;
//const _DATA_READER_QOS *DDS_DATAREADER_QOS_DEFAULT = NULL;
/*
*Nephalem
*ACK_Kind RTi定义 可不使用
*/
typedef unsigned int _Acknowledgment;
const _Acknowledgment PROTOCOL_ACKNOWLEDGMENT = 0x00000000;
struct _ACK_KIND_QOS_POLICY:_QOS_POLICY
{
	_Acknowledgment Kind;

	_ACK_KIND_QOS_POLICY()
	{
		Name = ACKKINDQOSPOLICY;
		Kind = PROTOCOL_ACKNOWLEDGMENT;
	}
};
/*
*Nephalem
*_EXPECTS_ACK  RTPS反对使用 可不使用
*/
struct _EXPECTS_ACK:_QOS_POLICY
{
	bool Value;

	_EXPECTS_ACK()
	{
		Name = EXPECTSACKQOSPOLICY;
		Value = TRUE;
	}
};

typedef unsigned short _PARAMETERID_T;
struct _PARAMETER_T
{
	_PARAMETERID_T Name;
};

/*
*Nephalem
*_SEND_QUEUE_SIZE  RTPS反对使用 可不使用
*/
struct _SEND_QUEUE_SIZE:_PARAMETER_T
{
	unsigned int Value;

	_SEND_QUEUE_SIZE()
	{
		Name = PID_SEND_QUEUE_SIZE;
		Value = 0xFFFFFFFF;
	}
};
/*
*Nephalem
*_RECV_QUEUE_SIZE  RTPS反对使用 可不使用
*/
struct _RECV_QUEUE_SIZE:_PARAMETER_T
{
	unsigned int Value;

	_RECV_QUEUE_SIZE()
	{
		Name = PID_RECV_QUEUE_SIZE;
		Value = 0xFFFFFFFF;
	}
};
/*
*Nephalem
*_PERSISTENCE  RTPS反对使用 可不使用
*/
struct _PERSISTENCE:_PARAMETER_T
{
	_DURATION_T Time;

	_PERSISTENCE()
	{
		Name = PID_PERSISTENCE;
		Time.lSecond = 0;
		Time.ulNanosec = 0;
	}
};
/*
*Nephalem
*_GROUP_ENTITY_TD_T  备用
*/
struct _GROUP_ENTITY_TD_T: _PARAMETER_T
{
	_ENTITY_ID_T Entity;

	_GROUP_ENTITY_TD_T()
	{
		Name = PID_GROUP_ENTITY_ID;
	}
};
/*
*Nephalem
*_TYPE_MAX_SIZE_SERIALIZED  备用
*/
struct _TYPE_MAX_SIZE_SERIALIZED:_PARAMETER_T
{
	unsigned int Value;

	_TYPE_MAX_SIZE_SERIALIZED()
	{
		Name = PID_TYPE_MAX_SIZE_SERIALIZED;
		Value = 28;
	}
};
/*
*Nephalem
*_ENTITY_VIRTUAL_GUID  备用
*/
struct _ENTITY_VIRTUAL_GUID:_PARAMETER_T
{
	_GUID_PREFIX_T GuidPrefix;
	_ENTITY_ID_T VirtualGuidSuffix;

	_ENTITY_VIRTUAL_GUID()
	{	
		Name = PID_ENTITY_VIRTUAL_GUID;
	}
};
/*
*Nephalem
*_DIRECT_COMMUNTICATION  备用
*/
struct _DIRECT_COMMUNTICATION:_PARAMETER_T
{
	bool Value[4];
	_DIRECT_COMMUNTICATION()
	{
		Name = PID_DIRECT_COMMUNICATION;
		memset(Value,0,4);
		Value[0] = true;
	}
};
/*
*Nephalem
*_DISABLE_POSITIVE_ACKS  备用
*/
struct _DISABLE_POSITIVE_ACKS:_PARAMETER_T
{
	bool Value[4];

	_DISABLE_POSITIVE_ACKS()
	{
		Name = PID_DISABLE_POSITIVE_ACKS;
		memset(Value,0,4);
	}
};
/*
*Nephalem
*_TYPE_CONSISTENCY  备用
*/
const unsigned int ALLOW_TYPE_COERCION = 1;
struct _TYPE_CONSISTENCY:_PARAMETER_T
{
	unsigned int Kind;
	_TYPE_CONSISTENCY()
	{
		Name = PID_TYPE_CONSISTENCY;
		Kind = ALLOW_TYPE_COERCION;
	}
};
/*
*Nephalem
*_EXPECTS_VIRTUAL_HB  备用
*/
struct _EXPECTS_VIRTUAL_HB:_PARAMETER_T
{
	bool Value[4];
	_EXPECTS_VIRTUAL_HB()
	{
		Name = PID_EXPECTS_VIRTUAL_HB;
		memset(Value,0,4);
	}
};
/*
*Nephalem
*_OWNERSHIP_STRENGTH_QOS_POLICY  备用
*/
typedef int _OWNERSHIP_STRENGTH_VALUE_T;
struct _OWNERSHIP_STRENGTH_QOS_POLICY : _QOS_POLICY
{
	_OWNERSHIP_STRENGTH_VALUE_T Value;

	_OWNERSHIP_STRENGTH_QOS_POLICY()
	{
		this->Name = OWNERSHIPSTRENGTHQOSPOLICY;
		this->Value = 0;
	}

	_OWNERSHIP_STRENGTH_QOS_POLICY & operator = (const _OWNERSHIP_STRENGTH_QOS_POLICY &right)
	{
		this->Value = right.Value;
		return *this;
	}
};

/*
*Nephalem
*PRIVILAGE_STRENGTH_QOS_POLICY  备用
*/
typedef int _PRIVILAGE_STRENGTH_VALUE_T;
typedef int _THRESHOLD_VALUE_T;
struct _PRIVILAGE_STRENGTH_QOS_POLICY : _QOS_POLICY
{
	_PRIVILAGE_STRENGTH_VALUE_T Value;
	_THRESHOLD_VALUE_T Threshold;

	_PRIVILAGE_STRENGTH_QOS_POLICY()
	{
		this->Name = PRIVILAGESTRENGTHQOSPOLICY;
		this->Value = 20;
		this->Threshold = 20;
	}

	_PRIVILAGE_STRENGTH_QOS_POLICY & operator = (const _PRIVILAGE_STRENGTH_QOS_POLICY &right)
	{
		this->Value = right.Value;
		this->Threshold = right.Threshold;
		return *this;
	}
};

/*
*Nephalem
*_RESOURCE_LIMITS_QOS_POLICY  备用
*/
const unsigned int LENGTH_UNLIMITED = 1024;

struct _RESOURCE_LIMITS_QOS_POLICY : _QOS_POLICY
{
	unsigned int max_samples;
	unsigned int max_instances;
	unsigned int max_samples_per_instance;

	_RESOURCE_LIMITS_QOS_POLICY()
	{
		max_samples = LENGTH_UNLIMITED;
		max_instances = LENGTH_UNLIMITED;
		max_samples_per_instance = LENGTH_UNLIMITED;
	}

	_RESOURCE_LIMITS_QOS_POLICY & operator = (const _RESOURCE_LIMITS_QOS_POLICY &right)
	{
		this->max_samples = right.max_samples;
		this->max_instances = right.max_instances;
		this->max_samples_per_instance = right.max_samples_per_instance;
		return *this;
	}
};

class _IDL_SEQUENCE_octet;
typedef map<_GUID_T, _IDL_SEQUENCE_octet*> _GUID_USERDATA_MAP_T;
//dsw add for User Data QoS 2015-10-31
//default: length = 0; maximum = 256; 
//在创建发布者、订阅者之前就需要设置： enabled = true
struct _USER_DATA_QOS_POLICY : _QOS_POLICY
{
	_IDL_SEQUENCE_octet *value;
	bool enabled;
	_USER_DATA_QOS_POLICY()
	{
		this->Name = USERDATAQOSPOLICY;
		this->value = NULL;
		this->enabled = false;
	}
};

struct _PARTITION_QOS_POLICY : _QOS_POLICY
{
	vector<string> value;
	_PARTITION_QOS_POLICY(){

		this->Name = PARTITIONQOSPOLICY;
	}

	_PARTITION_QOS_POLICY & operator = (const _PARTITION_QOS_POLICY &right)
	{
		this->value = right.value;
		return *this;
	}
};

/*
*Nephalem
*_READER_DATA_LIFECYCLE_QOS_POLICY  备用
*/
struct _READER_DATA_LIFECYCLE_QOS_POLICY : _QOS_POLICY
{
	_DURATION_T autopurge_nowriter_samples_delay;
	_DURATION_T autopurge_disposed_samples_delay;

	_READER_DATA_LIFECYCLE_QOS_POLICY()
	{
		this->Name = READERDATALIFECYCLEQOSPOLICY;
		this->autopurge_nowriter_samples_delay = TIME_INFINITE;
		this->autopurge_disposed_samples_delay = TIME_INFINITE;
	}

	_READER_DATA_LIFECYCLE_QOS_POLICY & operator = (const _READER_DATA_LIFECYCLE_QOS_POLICY &right)
	{
		this->autopurge_nowriter_samples_delay = right.autopurge_nowriter_samples_delay;
		this->autopurge_disposed_samples_delay = right.autopurge_disposed_samples_delay;
		return *this;
	}
};

/*
*Nephalem
*_PERIOD_PUBLICATION_QOS_POLICY  备用
*/
struct _PERIOD_PUBLICATION_QOS_POLICY : _QOS_POLICY
{
	_DURATION_T Period;

	_PERIOD_PUBLICATION_QOS_POLICY()
	{
		this->Name = PERIODPUBLICATION;
		this->Period = TIME_INVALID;
	}

	_PERIOD_PUBLICATION_QOS_POLICY & operator = (const _PERIOD_PUBLICATION_QOS_POLICY &right)
	{
		this->Period = right.Period;
		return *this;
	}
};

/*
*Nephalem
*_EMERGENCY_QOS_POLICY  备用
*/
struct _EMERGENCY_QOS_POLICY : _QOS_POLICY
{
	unsigned int emergencyValue;

	_EMERGENCY_QOS_POLICY()
	{
		this->Name = EMERGENCYQOSPOLICY;
		this->emergencyValue = 0;
	}

	_EMERGENCY_QOS_POLICY & operator = (const _EMERGENCY_QOS_POLICY &right)
	{
		this->emergencyValue = right.emergencyValue;
		return *this;
	}
};

/*
*Nephalem
*_TRANSPORT_PRIORITY_QOS_POLICY  备用
*/
struct _TRANSPORT_PRIORITY_QOS_POLICY : _QOS_POLICY
{
	unsigned int transport_pri_value;

	_TRANSPORT_PRIORITY_QOS_POLICY()
	{
		this->Name = TRANSPORT_PRIORITY_QOS_POLICY;
		this->transport_pri_value = 0;
	}

	_TRANSPORT_PRIORITY_QOS_POLICY & operator = (const _TRANSPORT_PRIORITY_QOS_POLICY &right)
	{
		this->transport_pri_value = right.transport_pri_value;
		return *this;
	}
};
/*
*Nephalem
*_LIVELINESS_QOS_POLICY  备用
*/
enum _LIVELINESS_KIND_T {AUTOMATIC_LIVELINESS_QOS, MANUAL_BY_PARTICIPANT_LIVELINESS_QOS, MANUAL_BY_TOPIC_LIVELINESS_QOS};
struct _LIVELINESS_QOS_POLICY : _QOS_POLICY
{
	_LIVELINESS_KIND_T Kind;
	_DURATION_T lease_duration;

	_LIVELINESS_QOS_POLICY()
	{
		this->Name = LIVELINESSQOSPOLICY;
		this->Kind = AUTOMATIC_LIVELINESS_QOS;
		this->lease_duration = TIME_INFINITE;
	}

	_LIVELINESS_QOS_POLICY & operator = (const _LIVELINESS_QOS_POLICY &right)
	{
		this->Kind = right.Kind;
		this->lease_duration = right.lease_duration;
		return *this;
	}
};


//dsw add for Durability Service QoS 2015-10-18
struct _DURABILITY_SERVICE_QOS_POLICY : _QOS_POLICY
{
	_DURATION_T service_cleanup_delay;
	//for History
	_HISTORY_KIND_T Kind;
	unsigned int Depth;
	//for Resource_Limits
	unsigned int max_samples;
	unsigned int max_instances;
	unsigned int max_samples_per_instance;

	_DURABILITY_SERVICE_QOS_POLICY()
	{
		this->Name = DURABILITYSERVICEQOSPOLICY;
		this->service_cleanup_delay = TIME_ZERO;
		this->Kind = KEEP_LAST;
		this->Depth = 1;
		this->max_samples = LENGTH_UNLIMITED;
		this->max_instances = LENGTH_UNLIMITED;
		this->max_samples_per_instance = LENGTH_UNLIMITED;
	}

	_DURABILITY_SERVICE_QOS_POLICY & operator = (const _DURABILITY_SERVICE_QOS_POLICY &right)
	{
		this->Kind = right.Kind;
		this->Depth = right.Depth;
		this->max_samples = right.max_samples;
		this->max_instances = right.max_instances;
		this->max_samples_per_instance = right.max_samples_per_instance;
		return *this;
	}

};
/*
*Nephalem
*_OWNERSHIP_QOS_POLICY  备用
*/
typedef int _OWNERSHIP_KIND_T;
#define SHARED 0
#define EXCLUSIVE 2

struct _OWNERSHIP_QOS_POLICY : _QOS_POLICY
{
	_OWNERSHIP_KIND_T Kind;

	_OWNERSHIP_QOS_POLICY()
	{
		this->Name = OWNERSHIPQOSPOLICY;
		this->Kind = SHARED;
	}

	_OWNERSHIP_QOS_POLICY & operator = (const _OWNERSHIP_QOS_POLICY &right)
	{
		this->Kind = right.Kind;
		return *this;
	}
};
/*
*Nephalem
*_PRESENTATION_QOS_POLICY  备用
*/
typedef unsigned int _ACCESS_SCOPE;
const _ACCESS_SCOPE INSTANCE_PRESENTATION_QOS = 0;
struct _PRESENTATION_QOS_POLICY:_QOS_POLICY
{
	_ACCESS_SCOPE AccessScope;
	bool bAccess[4];

	_PRESENTATION_QOS_POLICY()
	{
		Name = PRESENTATIONQOSPOLICY;
		AccessScope = INSTANCE_PRESENTATION_QOS;
		memset(bAccess,0,4);
	}
};

/*
*Nephalem
*_DESTINATION_ORDER_QOS_POLICY  备用
*/
typedef int _DESTINATION_ORDER_KIND_T;
#define BY_RECEPTION_TIMESTAMP 0
#define BY_SOURCE_TIMESTAMP 2
struct _DESTINATION_ORDER_QOS_POLICY : _QOS_POLICY{
	_DESTINATION_ORDER_KIND_T Kind;
	_DESTINATION_ORDER_QOS_POLICY()
	{
		this->Name = DESTINATIONORDERQOSPOLICY;
		this->Kind = BY_RECEPTION_TIMESTAMP;
	}
	_DESTINATION_ORDER_QOS_POLICY & operator = (const _DESTINATION_ORDER_QOS_POLICY &right)
	{
		this->Kind = right.Kind;
		return *this;
	}
};
/*
*Nephalem
*_LATENCY_BUDGET_QOS_POLICY  备用
*/
struct _LATENCY_BUDGET_QOS_POLICY : _QOS_POLICY
{
	_DURATION_T Duration;

	_LATENCY_BUDGET_QOS_POLICY()
	{
		this->Name = LATENCY_BUDGETQOSPOLICY;
		this->Duration = TIME_ZERO;
	}

	_LATENCY_BUDGET_QOS_POLICY & operator = (const _LATENCY_BUDGET_QOS_POLICY &right)
	{
		this->Duration = right.Duration;
		return *this;
	}
};

/*
*Nephalem
*_LIFESPAN_QOS_POLICY  备用
*/
struct _LIFESPAN_QOS_POLICY : _QOS_POLICY
{
	_DURATION_T Duration;

	_LIFESPAN_QOS_POLICY()
	{
		this->Name = LIFESPANQOSPOLICY;
		this->Duration = TIME_ONE_MINUTE;
	}

	_LIFESPAN_QOS_POLICY & operator = (const _LIFESPAN_QOS_POLICY &right)
	{
		this->Duration = right.Duration;
		return *this;
	}
};
/*
*Nephalem
*_SERVICE_KIND_QOS_POLICY  备用
*/
const unsigned int NO_SERVICE_QOS = 0x00000000;
struct _SERVICE_KIND_QOS_POLICY:_QOS_POLICY
{
	unsigned int Kind;

	_SERVICE_KIND_QOS_POLICY()
	{
		//Name = PID_SERVICE_KIND;
		//Kind = NO_SERVICE_QOS;
	};
};

struct _TIME_BASED_FILTER_QOS_POLICY : _QOS_POLICY
{
	_DURATION_T Minimum_Separation;

	_TIME_BASED_FILTER_QOS_POLICY()
	{
		this->Name = TIMEBASEDFILTERQOSPOLICY;
		this->Minimum_Separation = TIME_ZERO;
	}

	_TIME_BASED_FILTER_QOS_POLICY & operator = (const _TIME_BASED_FILTER_QOS_POLICY &right)
	{
		this->Minimum_Separation = right.Minimum_Separation;
		return *this;
	}
};
struct _ENTITY_QOS 
{
    struct _RELIABILITY_QOS_POLICY			Reliability;
    struct _DEADLINE_QOS_POLICY				Deadline;
	struct _OWNERSHIP_QOS_POLICY			Ownership;
	struct _OWNERSHIP_STRENGTH_QOS_POLICY	OwnershipStrength;
	struct _PRIVILAGE_STRENGTH_QOS_POLICY	Privilage;
	struct _LIVELINESS_QOS_POLICY			Liveliness;
	struct _TIME_BASED_FILTER_QOS_POLICY	Time_Based_Filter;
	struct _HISTORY_QOS_POLICY				History;
	struct _RESOURCE_LIMITS_QOS_POLICY		ResourceLimits;
	struct _DURABILITY_QOS_POLICY			Durability;
	struct _DURABILITY_SERVICE_QOS_POLICY	DurabilityService;
	struct _DESTINATION_ORDER_QOS_POLICY	DestinationOrder;
	struct _MULTI_NETWORK_CARD_QOS_POLICY	MultiNetCard;//2015-3-17 hjy add MultiNetworkCard support
	struct _USER_DATA_QOS_POLICY			UserData;
	struct _PARTITION_QOS_POLICY			Partiton;
	struct _LATENCY_BUDGET_QOS_POLICY		LatencyBudget;

	_ENTITY_QOS & operator = (const _ENTITY_QOS &right)
	{
		this->Reliability	= right.Reliability;
		this->Deadline		= right.Deadline;
		this->Durability	= right.Durability;
		this->Ownership		= right.Ownership;
		this->OwnershipStrength = right.OwnershipStrength;
		this->Privilage		= right.Privilage;
		this->Liveliness	= right.Liveliness;
		this->Time_Based_Filter = right.Time_Based_Filter;
		this->History		= right.History;
		this->ResourceLimits = right.ResourceLimits;
		this->Durability	= right.Durability;
		this->DurabilityService	= right.DurabilityService;
		this->DestinationOrder = right.DestinationOrder;
		this->UserData		= right.UserData;
		this->Partiton		= right.Partiton;
		this->LatencyBudget = right.LatencyBudget;
		this->MultiNetCard	= right.MultiNetCard;
		return *this;
	}

};
//struct _DATA_WRITER_QOS;
struct _DATA_READER_QOS : public _ENTITY_QOS 
{
	//bool operator== (const _DATA_WRITER_QOS& Right) const;
	struct _MASS_DATA_QOS_POLICY Mass_Data;
	struct _READER_DATA_LIFECYCLE_QOS_POLICY ReaderDataLifecycle;
};

struct _DATA_WRITER_QOS : public _ENTITY_QOS 
{
	//重载运算符 ==
	bool operator== (const _DATA_READER_QOS& Right) const
    {
		if(this->Reliability.Kind != Right.Reliability.Kind)
			return false;
		if(this->Deadline.Period > Right.Deadline.Period)
			return false;
		if(this->Durability.Kind < Right.Durability.Kind)
			return false;
		return true;
	}
	//大数据
	struct _MASS_DATA_QOS_POLICY Mass_Data;

	struct _PERIOD_PUBLICATION_QOS_POLICY PeriodPublication;//hjy add for period publication QoS 2014-10-27

	struct _TRANSPORT_PRIORITY_QOS_POLICY TransportPriority;

	struct _LIFESPAN_QOS_POLICY Lifespan;

	struct _EMERGENCY_QOS_POLICY Emergency;

};
//重载运算符 ==
//bool _DATA_READER_QOS::operator== (const _DATA_WRITER_QOS& Right) const{
//	if(this->Reliability.Kind != Right.Reliability.Kind)
//		return false;
//	if(this->Deadline.Period < Right.Deadline.Period)
//		return false;
//	if(this->Durability.Kind > Right.Durability.Kind)
//		return false;
//	return true;
//}


//const _DATA_WRITER_QOS *DDS_DATAWRITER_QOS_DEFAULT = NULL;
//const _DATA_READER_QOS *DDS_DATAREADER_QOS_DEFAULT = NULL;



/**
* @ brief 定义数据域
*/
typedef long _DOMAINID_T;

/**
* @ brief 定义序号
*/
typedef int _COUNT_T;

/**
* @ brief 定义RTPS协议版本  RTPS Protocol Version
*/
struct _PROTOCOL_VERSION_T 
{
    Octet Major;
    Octet Minor;

    _PROTOCOL_VERSION_T operator = (const _PROTOCOL_VERSION_T &Right) 
    {
        this->Major = Right.Major;
        this->Minor = Right.Minor;

        return *this;
    }
};
const _PROTOCOL_VERSION_T PROTOCOLVERSION_1_0 = {1, 0};
const _PROTOCOL_VERSION_T PROTOCOLVERSION_1_1 = {1, 1};
const _PROTOCOL_VERSION_T PROTOCOLVERSION_2_0 = {2, 0};
const _PROTOCOL_VERSION_T PROTOCOLVERSION_2_1 = {2, 1};
#define PROTOCOLVERSION PROTOCOLVERSION_2_1

/**
* @ brief 定义请求队列
*/ 
class Request;
typedef list<Request *> _REQUEST_LIST_T;

//大数据
class MassDataRequest;
typedef list<MassDataRequest *> _MASSDATA_REQUEST_LIST_T;
/**
* @ brief 定义报文接收信息结构
*/ 
struct _RECEIVER 
{
    _PROTOCOL_VERSION_T SourceVersion;
    _VENDOR_ID_T SourceVendorId;
    _GUID_PREFIX_T SourceGuidPrefix;
    _GUID_PREFIX_T DestGuidPrefix;
    _LOCATOR_LIST_T UnicastReplyLocatorList;
    _LOCATOR_LIST_T MulticastReplyLocatorList;
    bool bHaveTimestame;
    _TIME_T Timestamp;
};

/**
* @ brief 定义Socket vxworks
*/ 
#if defined VXWORKS || defined KYLIN  //移植
typedef int _SOCKET_T;
#elif WIN32
typedef SOCKET _SOCKET_T;
#endif

typedef list<_SOCKET_T> _SOCKET_LIST_T;

/**
* @ brief 定义端点Endpoint 列表
* @       可以通过EntityId快速查找Endpoint
*/ 
class Endpoint;
typedef map<_ENTITY_ID_T, Endpoint*> _ENDPOINT_LIST_T;

/**
* @ brief 定义多播地址与端点映射对应关系
* @       可以通过多播地址查找_ENDPOINT_LIST_T
*/ 
typedef map<unsigned long, _ENDPOINT_LIST_T> _ENDPOINT_MULTI_ADDR_LIST_T;

/**
* @ brief 定义接收缓冲区大小 字节
*/ 
#define RECEIVE_BUFFER_SIZE 6553600

/**
* @ brief 定义Listener监听的状态集
*/
typedef unsigned long _STATUS_MASK;
#define STATUS_MASK_NULL                                0x00000000
#define STATUS_MASK_ALL                                 0xFFFFFFFF
#define STATUS_MASK_ON_DATA_AVAILABLE                   0x00000001 << 1
#define STATUS_MASK_ON_OFFERED_DEADLINE_MISSED          0x00000001 << 2
#define STATUS_MASK_ON_REQUESTED_DEADLINE_MISSED        0x00000001 << 3

/**
* @ brief 定义Change的类型
*/
typedef unsigned short _CHANGE_KIND_T;
#define ALIVE                   0x0001 << 0
#define NOT_ALIVE_DISPOSED      0x0001 << 1
#define NOT_ALIVE_UNREGISTERED  0x0001 << 2
//*Nephalem
#define ALIVE_UD				0x0011
#define ALIVE_FRAG				0x0111

/**
* @ brief 定义_INSTANCE_HANDLE实体标识类型
*/
#define RTPS_KEY_HASH_MAX_LENGTH 16

struct _RTPS_KEY_HASH 
{
    unsigned char szValue[RTPS_KEY_HASH_MAX_LENGTH];
    unsigned int ulLength;

    //默认构造函数
    //_RTPS_KEY_HASH () {
    //    memset(szValue, 0, RTPS_KEY_HASH_MAX_LENGTH);
    //    ulLength = RTPS_KEY_HASH_MAX_LENGTH;
    //}

    //重载运算符 =
    _RTPS_KEY_HASH operator= (const _RTPS_KEY_HASH& Right) 
    {
        memcpy(this->szValue, Right.szValue, RTPS_KEY_HASH_MAX_LENGTH);
        this->ulLength = Right.ulLength;
        return *this;
    }

    //重载运算符 ==
    bool operator== (const _RTPS_KEY_HASH& Right) const 
    {
        if(this->ulLength == Right.ulLength) 
        {
        	unsigned int iPos = 0;
            const unsigned char *pLtkh, *pRtkh;
            while(iPos < this->ulLength) 
            {
                pLtkh = this->szValue + iPos;
                pRtkh = Right.szValue + iPos;
                if(*pLtkh != *pRtkh) 
                {
                    return false;
                }
                else 
                {
                    iPos++;
                }
            }
            return true;
        }
        else 
        {
            return false;
        }
    }

    //重载运算符 !=
    bool operator!= (const _RTPS_KEY_HASH& Right) const 
    {
        return(!(*this == Right));
    }

    //重载运算符 >
    bool operator> (const _RTPS_KEY_HASH& Right) const 
    {
        int iPos = 0;
        const unsigned char *pLtkh, *pRtkh;
        while(iPos < RTPS_KEY_HASH_MAX_LENGTH) 
        {
            pLtkh = this->szValue + iPos;
            pRtkh = Right.szValue + iPos;
            if(*pLtkh > *pRtkh) 
            {
                return true;
            }
            else if(*pLtkh < *pRtkh) 
            {
                return false;
            }
            else 
            {
                iPos++;
            }
        }
        return false;
    }

    //重载运算符 <
    bool operator< (const _RTPS_KEY_HASH& Right) 
    {
        return(!(*this > Right) && *this != Right);
    }
};
struct _INSTANCE_HANDLE 
{
    struct _RTPS_KEY_HASH _KEY_HASH;
    bool bIsValid;

    //默认构造函数
    //_INSTANCE_HANDLE() {
    //    memset(_KEY_HASH.szValue, 0, RTPS_KEY_HASH_MAX_LENGTH);
    //    _KEY_HASH.ulLength = RTPS_KEY_HASH_MAX_LENGTH;
    //    bIsValid = false;
    //}

    //重载运算符 =
    _INSTANCE_HANDLE operator= (const _INSTANCE_HANDLE& Right) 
    {
        this->_KEY_HASH = Right._KEY_HASH;
        this->bIsValid = Right.bIsValid;
        return *this;
    }

    //重载运算符 ==
    bool operator== (const _INSTANCE_HANDLE& Right) const 
    {
        return(this->_KEY_HASH == Right._KEY_HASH && this->bIsValid == Right.bIsValid);
    }

    //重载运算符 !=
    bool operator!= (const _INSTANCE_HANDLE& Right) const 
    {
        return(this->_KEY_HASH != Right._KEY_HASH || this->bIsValid != Right.bIsValid);
    }

    //重载运算符 >
    bool operator> (const _INSTANCE_HANDLE& Right) const
    {
        return(this->_KEY_HASH > Right._KEY_HASH || (this->bIsValid && !(Right.bIsValid)));
    }

    //重载运算符 <
    bool operator< (const _INSTANCE_HANDLE& Right) const 
    {
        return(!(*this > Right) && *this != Right);
    }

    void print() 
    {
        for(unsigned int I = 0; I < this->_KEY_HASH.ulLength; I++)
        {
      //      //cout<<this->_KEY_HASH.szValue[I];
        }
        //cout<<endl;
    }
};
typedef struct _INSTANCE_HANDLE _INSTANCE_HANDLE_T;
typedef struct _RTPS_KEY_HASH _KEY_HASH_T;
#define RTPS_KEY_HASH_NIL {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
#define RTPS_KEY_HASH_DEFAULT { \
RTPS_KEY_HASH_NIL,  /* szValue */\
RTPS_KEY_HASH_MAX_LENGTH/* ulLength */\
}
#define INSTANCE_HANDLE_NIL { \
RTPS_KEY_HASH_DEFAULT, \
FALSE /* bIsValid */ }
const _INSTANCE_HANDLE_T HANDLE_NIL = INSTANCE_HANDLE_NIL;


typedef list< pair<_SEQUENCE_NUMBER_T, _INSTANCE_HANDLE_T> > _SEQ_NUM_TO_HANDLE;

/**
* @ brief 定义_CACHE_CHANGE格式
*/
struct _CACHE_CHANGE 
{
    _CHANGE_KIND_T Kind;
    _GUID_T WriterGuid;
    _INSTANCE_HANDLE_T InstanceHandle;
    _SEQUENCE_NUMBER_T SequenceNumber;
    _TIME_T Timestamp;
    unsigned long ulLength;
    char *pDatavalue;
};

/**
* @ brief 定义CacheChange的列表格式
*/
typedef list<_CACHE_CHANGE*> _CACHE_CHANGE_LIST_T;

/**
* @ brief 定义WriterProxy的列表格式
*/
class WriterProxy;
typedef map<_GUID_T, WriterProxy*> _WRITER_PROXY_LIST_T;

/**
* @ brief 定义HistoryCache中的索引格式
*/
typedef map<_SEQUENCE_NUMBER_T, unsigned long> _INDEX_T;

/**
* @ brief 定义从发布端接收的数据状态信息格式
*/
typedef Octet _CHANGE_FROM_WRITER_STATUS_KIND;
const _CHANGE_FROM_WRITER_STATUS_KIND WRITER_CHANGE_UNKNOWN = 0x00;
const _CHANGE_FROM_WRITER_STATUS_KIND WRITER_CHANGE_MISSING = 0x01;
const _CHANGE_FROM_WRITER_STATUS_KIND WRITER_CHANGE_REQUESTED = 0x02;
const _CHANGE_FROM_WRITER_STATUS_KIND WRITER_CHANGE_RECEIVED = 0x03;
const _CHANGE_FROM_WRITER_STATUS_KIND WRITER_CHANGE_LOST = 0x04;

struct _CHANGE_FROM_WRITER 
{
    _CHANGE_FROM_WRITER_STATUS_KIND Status;
    _SEQUENCE_NUMBER_T RemoteSeqNum;
    _SEQUENCE_NUMBER_T LocalSeqNum;
};

//发布端数据接收状态映射表
typedef map<_SEQUENCE_NUMBER_T, _CHANGE_FROM_WRITER*> _CHANGE_FROM_WRITER_LIST_T;

/**
* @ brief 定义ReaderProxy队列
*/
class ReaderProxy;
/*修改
struct ReaderProxyElement {
    ReaderProxy *readerProxy;
    struct ReaderProxyElement *pNext;
};
struct _READER_PROXY_LIST {
    unsigned long num;
    struct ReaderProxyElement *head, *tail;
};
*/
typedef map<_GUID_T, ReaderProxy*> _READER_PROXY_LIST;

/**
* @ brief 定义ReaderLocator队列
*/
class ReaderLocator;
typedef map<_GUID_T, ReaderLocator*> _READER_LOCATOR_LIST;

/**
* @ brief 定义发送端口队列
*/
typedef map<int, _SOCKET_T> _SEND_SOCKET_LIST;

/**
* @ brief 定义发布端发送向订阅端的数据状态信息格式
*/
typedef Octet _CHANGE_FOR_READER_STATUS_KIND;
const _CHANGE_FOR_READER_STATUS_KIND NEW = 0x00;
const _CHANGE_FOR_READER_STATUS_KIND UNSENT = 0x01;
const _CHANGE_FOR_READER_STATUS_KIND REQUESTED = 0x02;
const _CHANGE_FOR_READER_STATUS_KIND UNDERWAY = 0x03;
const _CHANGE_FOR_READER_STATUS_KIND UNACKNOWLEDGED = 0x04;
const _CHANGE_FOR_READER_STATUS_KIND ACKNOWLEDGED = 0x05;

struct _CHANGE_FOR_READER
{
    _CHANGE_FOR_READER_STATUS_KIND Status;
    _SEQUENCE_NUMBER_T SequenceNumber;
   // _CHANGE_FOR_READER *pNext;
};

//struct _CHANGE_FOR_READER_LIST{  //修改4-29
//    unsigned long num;
//    _CHANGE_FOR_READER *head, *tail;
//};

typedef map<_SEQUENCE_NUMBER_T, _CHANGE_FOR_READER*> _CHANGE_FOR_READER_LIST;

/**
* @ brief 定义实体状态类型
*/
typedef unsigned short InstanceStateKind;
#define ALIVE                0x0001 << 0
#define NOT_ALIVE_DISPOSED   0x0001 << 1
#define NOT_ALIVE_NO_WRITERS 0x0001 << 2

/**
* @ brief 定义数据附加信息
*/
struct _SAMPLE_INFO 
{
    //实例的状态
    InstanceStateKind Instance_state;
    //发送时的时间戳
    _TIME_T Source_timestamp;
    //实例标识
    _INSTANCE_HANDLE_T Instance_handle;
    //是否是有效数据
    bool bValid_data;
};

//typedef list<_QOS_POLICY*> QosPolicyList;
typedef vector<_SAMPLE_INFO> _SAMPLE_INFO_SEQ;

/**
* @ brief 定义DomainParticipa的列表格式
*/
class DomainParticipant;
typedef list<DomainParticipant*> _DOMAIN_PARTICIPANT_LIST;
typedef map<unsigned long, _DOMAIN_PARTICIPANT_LIST> _DOMAIN_PARTICIPANT_MAP;

/**
* @ brief 定义内置端点集合标识
*/
typedef unsigned int _BUILTIN_ENDPOINT_SET_T;
#define DISC_BUILTIN_ENDPOINT_PARTICIPANT_ANNOUNCER         0x00000001 << 0
#define DISC_BUILTIN_ENDPOINT_PARTICIPANT_DETECTOR          0x00000001 << 1
#define DISC_BUILTIN_ENDPOINT_PUBLICATION_ANNOUNCER         0x00000001 << 2
#define DISC_BUILTIN_ENDPOINT_PUBLICATION_DETECTOR          0x00000001 << 3
#define DISC_BUILTIN_ENDPOINT_SUBSCRIPTION_ANNOUNCER        0x00000001 << 4
#define DISC_BUILTIN_ENDPOINT_SUBSCRIPTION_DETECTOR         0x00000001 << 5
#define DISC_BUILTIN_ENDPOINT_PARTICIPANT_PROXY_ANNOUNCER   0x00000001 << 6
#define DISC_BUILTIN_ENDPOINT_PARTICIPANT_PROXY_DETECTOR    0x00000001 << 7
#define DISC_BUILTIN_ENDPOINT_PARTICIPANT_STATE_ANNOUNCER   0x00000001 << 8
#define DISC_BUILTIN_ENDPOINT_PARTICIPANT_STATE_DETECTOR    0x00000001 << 9
#define BUILTIN_ENDPOINT_PARTICIPANT_MESSAGE_DATA_WRITER    0x00000001 << 10
#define BUILTIN_ENDPOINT_PARTICIPANT_MESSAGE_DATA_READER    0x00000001 << 11

/*
*Nephalem：传输信息
*/
struct _TRANSPORTINFO_T
{
	unsigned int ulClassId;
	unsigned int ulMessageSizeMax;

	//重载运算符 !=
	bool operator != (const _TRANSPORTINFO_T &Right) const
	{
		if (this->ulClassId == Right.ulClassId &&
			this->ulMessageSizeMax == Right.ulMessageSizeMax )
		{
			return false;
		}
		else
		{
			return true;
		}
	}

	//重载运算符 ==
	bool operator == (const _TRANSPORTINFO_T &Right)
	{
		if (this->ulClassId == Right.ulClassId &&
			this->ulMessageSizeMax == Right.ulMessageSizeMax)
		{
			return true;
		}
		else
		{
			return false;
		}
	}


};

typedef vector<_TRANSPORTINFO_T> _TRANSPORTINFO_LIST_T;

/**
*Nephalem _PROPERTYVALUE_T类型：
*iRealityLength为实际字节长度，iValueLength为4字节对齐后的长度
*/
struct _PROPERTYVALUE_T 
{
	int iValueLength;
	int iRealityLength;
	char* pValue;
	_PROPERTYVALUE_T()
	{
		iValueLength = 0;
		pValue = NULL;
	}
	_PROPERTYVALUE_T(int iLength)
	{
		iValueLength = iLength;
		iRealityLength =((iValueLength-1)/4+1)*4;
		pValue = new char[iRealityLength];
	}
	_PROPERTYVALUE_T(char* pChar)
	{
		iValueLength = strlen(pChar) + 1;
		iRealityLength =((iValueLength-1)/4+1)*4;
		pValue = new char[iRealityLength]();
		memcpy(pValue,pChar,iValueLength);
		//for (int i = 0;i < iValueLength; i++)
		//{
		//	pValue[i] = pChar[i];
		//}

	}
	_PROPERTYVALUE_T operator = (const int iLength)
	{
		iValueLength = iLength;
		iRealityLength = ((iValueLength-1)/4+1)*4;
		pValue = new char[iRealityLength];
		return* this;
	}

	_PROPERTYVALUE_T operator = (const char* pChar)
	{
		iValueLength = strlen(pChar) + 1;
		iRealityLength =((iValueLength-1)/4+1)*4;
		pValue = new char[iRealityLength]();
		memcpy(pValue,pChar,iValueLength);
		//for (int i = 0;i < iValueLength; i++)
		//{
		//	pValue[i] = pChar[i];
		//}
		return* this;
	}
};
struct _PROPERTY_T
{
	_PROPERTYVALUE_T PropertyName;
	_PROPERTYVALUE_T PropertyValue;

};
typedef vector<_PROPERTY_T> _PROPERTY_LIST_T;

/**
*Nephalem 产品版本
*/
struct _PRODUCT_VERSION_T
{
	Octet Major;
	Octet Minor;
	Octet Release;
	Octet Revision;

	_PRODUCT_VERSION_T operator = (const _PRODUCT_VERSION_T &Right)
	{
		this->Major = Right.Major;
		this->Minor = Right.Minor;
		this->Release = Right.Release;
		this->Revision = Right.Revision;

		return *this;
	}
};

const _PRODUCT_VERSION_T PRODUCTVERSION_1_0_0_0 = {1,0,0,0};

/**
* @ brief 定义端点状态
*/
enum _ENTITY_STATUS_T 
{
    CREATION,
    MODIFICATION,
    DELETION,
    EXTENSION
};

/**
* @ brief 定义SPDP所需的数据格式
*/
//Participant信息
struct _PARTICIPANT_PROXY_DATA 
{
    //@Nephalem 变量顺序不能变，否则会导致赋值错误
    _GUID_PREFIX_T GuidPrefix;
	_ENTITY_ID_T EntityId;
	 _BUILTIN_ENDPOINT_SET_T AvailableBuiltinEndpoints;
	_PROTOCOL_VERSION_T ProtocolVersion;
    _VENDOR_ID_T VendorId;
   
    _LOCATOR_LIST_T MetatrafficUnicastLocatorList;
    _LOCATOR_LIST_T MetatrafficMulticastLocatorList;
    _LOCATOR_LIST_T DefaultUnicastLocatorList;
    _LOCATOR_LIST_T DefaultMulticastLocatorList;
};

//传输中使用的Participant信息
struct _SPDP_DISCOVERED_PARTICIPANT_DATA : public _PARTICIPANT_PROXY_DATA
{
	
	_PRODUCT_VERSION_T ProductVersion;
	_PROPERTY_LIST_T PropertyList;
	_DURATION_T LeaseDuration;
	unsigned int PeerHostEpoch;
	unsigned int DomainId;
	_TRANSPORTINFO_LIST_T TranSportInfoList;
	_TIME_T ReceiveTime;
	_ENTITY_STATUS_T Status;
};

typedef list<_SPDP_DISCOVERED_PARTICIPANT_DATA *> _PARTICIPANT_DATALIST_T;
/**
* @ brief 定义SEDP中使用的发布端数据的格式
*/
//发布端信息
struct _WRITER_PROXY_DATA 
{
    _GUID_T RemoteWriterGuid;
    _LOCATOR_LIST_T UnicastLocatorList;
    _LOCATOR_LIST_T MulticastLocatorList;
};

//发布主题信息
struct _PUBLICATION_BUILTIN_TOPIC_DATA 
{
	string strTopic_name;
	string strType_name;
	_RELIABILITY_QOS_POLICY Reliability;
	_OWNERSHIP_STRENGTH_QOS_POLICY OwnershipStrength;
	_LIVELINESS_QOS_POLICY Liveliness;
	_DURABILITY_QOS_POLICY Durability;
	_DURABILITY_SERVICE_QOS_POLICY DurabilityService;
	_OWNERSHIP_QOS_POLICY Ownership;
	_PRESENTATION_QOS_POLICY Presentation;
	_DESTINATION_ORDER_QOS_POLICY DestinationOrder;
	_DEADLINE_QOS_POLICY Deadline;
	_LATENCY_BUDGET_QOS_POLICY LatencyBudget;
	_LIFESPAN_QOS_POLICY lifespan;
	_GROUP_ENTITY_TD_T GroupEntityID;
	_TYPE_MAX_SIZE_SERIALIZED TypeMaxSizeSerialized;
	_ENTITY_VIRTUAL_GUID EntityVirtualGuid;
	_SERVICE_KIND_QOS_POLICY ServiceKind;
	_PROTOCOL_VERSION_T ProtocolVersion;
	_VENDOR_ID_T VendorId;
	_PRODUCT_VERSION_T ProductVersion;
	_DISABLE_POSITIVE_ACKS DisablePositiveAcks;
};

//传输使用的发布端信息
struct _DISCOVERED_WRITER_DATA :
    public _WRITER_PROXY_DATA,
    public _PUBLICATION_BUILTIN_TOPIC_DATA 
{
	_ACK_KIND_QOS_POLICY AckKind;
	_EXPECTS_ACK ExpectsAck;
	_SEND_QUEUE_SIZE SendQueueSize;
	_PERSISTENCE Persisitence;

    _ENTITY_STATUS_T Status;
};
typedef list<_DISCOVERED_WRITER_DATA *> _PUBLICATIONS_DATA_LIST_T;
/**
* @ brief 定义SEDP中使用的订阅端数据的格式
*/
//订阅端信息
struct _READER_PROXY_DATA 
{
    _GUID_T RemoteReaderGuid;
    _LOCATOR_LIST_T UnicastLocatorList;
    _LOCATOR_LIST_T MulticastLocatorList;
};

//订阅主题信息
struct _SUBSCRIPTION_BUILTIN_TOPIC_DATA 
{
	string strTopic_name;
    string strType_name;
	_RELIABILITY_QOS_POLICY Reliability;
	_ACK_KIND_QOS_POLICY AckKind;
	_TIME_BASED_FILTER_QOS_POLICY TimeBasedFilter;
	_LIVELINESS_QOS_POLICY Liveliness;
	_DURABILITY_QOS_POLICY Durability;
	_DIRECT_COMMUNTICATION DirectCommuntication;
	_OWNERSHIP_QOS_POLICY Ownership;
	_PRESENTATION_QOS_POLICY Presentation;
	_DESTINATION_ORDER_QOS_POLICY DestinationOrder;
	_DEADLINE_QOS_POLICY Deadline;
	_LATENCY_BUDGET_QOS_POLICY LatencyBudget;
	_GROUP_ENTITY_TD_T GroupEntityID;
	_ENTITY_VIRTUAL_GUID EntityVirtualGuid;   //值与本地guid相同
	_SERVICE_KIND_QOS_POLICY ServiceKind;
	_PROTOCOL_VERSION_T ProtocolVersion;
	_VENDOR_ID_T VendorId;
	_PRODUCT_VERSION_T ProductVersion;
	_DISABLE_POSITIVE_ACKS DisablePositiveAcks;
	_EXPECTS_VIRTUAL_HB ExpectsVirtualHB;
	_TYPE_CONSISTENCY TypeConsistency;
};

//传输使用的订阅端信息
struct _DISCOVERED_READER_DATA :
    public _READER_PROXY_DATA,
    public _SUBSCRIPTION_BUILTIN_TOPIC_DATA 
{
	_RECV_QUEUE_SIZE RecvQueueSize;
    _ENTITY_STATUS_T Status;
};
typedef list<_DISCOVERED_READER_DATA *> _SUBSCRIPTIONS_DATA_LIST_T;

/**
* @ brief 记录Agent结构 类型信息
*/
//记录远端DomainParticipa信息的列表
struct _REMOTE_PARTICIPANT_DATA_NODE
{
    _SPDP_DISCOVERED_PARTICIPANT_DATA* RemoteParticipantData;
    _REMOTE_PARTICIPANT_DATA_NODE* NextRemoteParticipant;
};

/**
* @ brief 记录Agent结构 类型信息
* @ brief 记录Publisher、Subscriber、Topic、_TYPE、Ip、DataWriter、DataReader列表的格式
*/
class Agent;
struct _TYPE
{
    Agent *pAgent;
};
class Publisher;
class Subscriber;
class Topic;
class DataWriter;
class DataReader;
//class ContentFilteredTopic;
//class Filter;
typedef list <Publisher*> _PUBLISHER_LIST_T;
typedef list <Subscriber*> _SUBSCRIBER_LIST_T;
typedef list <Topic*> _TOPIC_LIST_T;
//typedef list <ContentFilteredTopic*> _CONTENT_FILTERED_TOPIC_LIST_T;
typedef list <_TYPE> _TYPE_LIST_T;
typedef list <unsigned long> _IP_LIST_T;
typedef list <DataWriter*> _DATA_WRITER_LIST_T;
typedef list <DataReader*> _DATA_READER_LIST_T;

/**
* @ brief 定义主题类型和typecode的对应关系
*/
class TypeCode;
typedef map<string, TypeCode*> _TYPE_CODE_LIST_T;
/**
* @ brief 定义_DDS_STRING类型
*/
typedef std::string _DDS_STRING;
typedef list<_DDS_STRING> _STRING_SEQ;



///**
//* @ brief 实体在DataWriter端的信息
//*/
//struct InstanceInfo_DW {
//    //instance的状态
//    InstanceStateKind InstanceState;
//};
//typedef map<_INSTANCE_HANDLE_T, InstanceInfo_DW> InstanceMap_DW;

/**
* @ brief 实体在Writer端的信息
*/
struct _INSTANCE_INFO_W 
{
    //instance的状态
    InstanceStateKind InstanceState;
    //上次发送的时间
    _TIME_T LastSendTime;
};
typedef map<_INSTANCE_HANDLE_T, _INSTANCE_INFO_W> _INSTANCE_MAP_W;


///**
//* @ brief 实体在DataReader端的信息
//*/
//struct InstanceInfo_DR {
//    //instance的状态
//    InstanceStateKind InstanceState;
//};
//typedef map<_INSTANCE_HANDLE_T, InstanceInfo_DR> InstanceMap_DR;

/**
* @ brief 实体在Reader端的信息
*/
struct _INSTANCE_INFO_FROM_W 
{
    _CHANGE_KIND_T InstanceState;
};
typedef map<_GUID_T, _INSTANCE_INFO_FROM_W> _WRITER_TO_INSTANCE_INFO;
struct _INSTANCE_INFO_R 
{
    //instance的状态
    InstanceStateKind InstanceState;
    //上次发送的时间
    _TIME_T LastRecvTime;
    //发布端该实例的信息
    _WRITER_TO_INSTANCE_INFO WritertoInstanceInfo;
};
typedef map<_INSTANCE_HANDLE_T, _INSTANCE_INFO_R> _INSTANCE_MAP_R;


/**
* @ brief 定义主题的类型，是否有Key
*/
typedef enum 
{
    NO_KEY,
    WITH_KEY
}_TOPIC_KIND_T;

/**
* @ brief 请求的Deadline未满足的状态
*/
struct _REQUESTED_DEADLINE_MISSED_STATUS 
{
	int lTotal_count;
	int lTotal_count_change;
    _INSTANCE_HANDLE_T Last_instance_handle;

    //重载运算符 =
    _REQUESTED_DEADLINE_MISSED_STATUS operator= (const _REQUESTED_DEADLINE_MISSED_STATUS& Right)
    {
        this->lTotal_count = Right.lTotal_count;
        this->lTotal_count_change = Right.lTotal_count_change;
        this->Last_instance_handle = Right.Last_instance_handle;
        return *this;
    }
};

/**
* @ brief 提供的Deadline未满足的状态
*/
struct _OFFERED_DEADLINE_MISSED_STATUS 
{
	int lTotal_count;
	int lTotal_count_change;
    _INSTANCE_HANDLE_T Last_instance_handle;

    //重载运算符 =
    _OFFERED_DEADLINE_MISSED_STATUS operator= (const _OFFERED_DEADLINE_MISSED_STATUS& Right) 
    {
        this->lTotal_count = Right.lTotal_count;
        this->lTotal_count_change = Right.lTotal_count_change;
        this->Last_instance_handle = Right.Last_instance_handle;
        return *this;
    }
};

/**
* @ brief 分片号
*/
typedef unsigned int _FRAGMENT_NUMBER_T;

/**
* @ brief 数据长度列表
*/
typedef vector<unsigned int> _MESSAGE_LENGTH_LIST_T;

/**
* @ brief 分片数据的指针、长度
*/
struct _FRAG_DATA 
{
	char* pData;
	unsigned int ulLength;
};

/**
* @ brief 数据分片号和数据的对应关系
*/
typedef map<_FRAGMENT_NUMBER_T, _FRAG_DATA> _FRAG_NUM_MAP_T;

/**
* @ brief 一个SequenceNumber对应的数据分片
*/
struct _FRAGMENT_DATA 
{
	_SEQUENCE_NUMBER_T SeqNum;
	_FRAG_NUM_MAP_T FragNumMap;
	_TIME_T LastUpdateTime;
	_FRAGMENT_NUMBER_T FragSum;
	_GUID_T WriterGUID;
};

//大数据
struct _MASS_FRAGMENT_DATA 
{
	unsigned int DataNum;
	_FRAG_NUM_MAP_T FragNumMap;
	_FRAGMENT_NUMBER_T FragSum;
	unsigned int Length;
	_GUID_T WriterGUID;
};
/**
* @ brief 数据分片列表
*/
typedef list<_FRAGMENT_DATA*> _FRAGMENT_DATA_LIST_T;
//大数据
typedef list<_MASS_FRAGMENT_DATA*> _MASS_FRAGMENT_DATA_LIST_T;
typedef _FRAG_DATA _MASS_DATA;
typedef list<_MASS_DATA*> _MASS_DATA_LIST_T;

/**
* @ brief 定义需要分片的数据大小和分片大小
*/
#define DATAFRAG_LENGTH 4200
#define DATAMESSAGE_LIMIT 8400

///**
//* @ brief 有键的_DDS_STRING类型
//*/
//struct KeyedString {
//    char* key;
//    char* szValue;
//};
//typedef struct KeyedString _KEYED_STRING_KEY_HOLDER;
//typedef vector<KeyedString> _KEYED_STRING_SEQ;
//typedef map<_INSTANCE_HANDLE_T, _KEYED_STRING_KEY_HOLDER> _INSTANCE_HANDLE_TO_KEY_HOLDER;

/**
* @ brief CDR和TypeCode类型定义
*/
class TypeCode;
typedef TypeCode *_TYPE_CODE_PTR;

//#ifdef WIN32
//typedef __int64 _LONG_LONG;
//typedef unsigned __int64 _U_LONG_LONG;
//#elif KYLIN
typedef long long _LONG_LONG;
typedef unsigned long long _U_LONG_LONG;
//#endif
typedef long double _LONG_DOUBLE;

/** 
* @ brief 默认的ContentFilteredTopic主题类型
*/
#define DDS_CONTENT_FILTERED_TOPIC_TYPE "DDSContentFilteredTopic"

/**
*Nephalem ip类型相关定义
*/
//#define LOCATOR_INVALID				    {LOCATOR_KIND_INVALID, LOCATOR_PORT_INVALID,LOCATOR_ADDRESS_INVALID}
#define LOCATOR_KIND_INVALID			 -1
#define LOCATOR_ADDRESS_INVALID			{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
#define LOCATOR_PORT_INVALID			 0
#define LOCATOR_KIND_RESERVED			 0
#define LOCATOR_KIND_UDPv4               1
#define LOCATOR_KIND_UDPv6               2

//*Nephalem
//大小端信息
typedef Octet EncapsulationKind[2];
const EncapsulationKind CDR_BE    = {0x00,0x00};
const EncapsulationKind CDR_LE    = {0x00,0x01};
const EncapsulationKind PL_CDR_BE = {0x00,0x02};
const EncapsulationKind PL_CDR_LE = {0x00,0x03};

//*Nephalem
//保存配置文件中的信息
struct _XML_COMMON_SET  
{
	//unsigned int ulHostIP;//xwq 注释 2019-12-23
	unsigned int ulCacheLength;
	unsigned int ulLocalIp;
	string		  BroadcastAddr;
	bool		  bUseMulticastDiscovery;
	unsigned int ulMultiAddr;
	bool		  bUseMulticast;
	unsigned int ulMulticastAddressLow;
	unsigned int ulMulticastAddressNumber;
	bool		  bUseMultiNetworkCard;
	int			  iMultiNetworkCardCount;
	unsigned int *ulMultiNetworkCardAddress;
	_DURATION_T   ResendPeriod;
	bool		  bUseSpecifiedAddr; 
	unsigned int SpecifiedIP;
	bool		  bUsePortReadd;
	_ENTITY_QOS	  DefaultQoS;
	int			  iMonitor;
	int			  iRecord;
	int			  iIsHistoricServer;
	int			  MulitHbPeriod;
	unsigned int reservedOne;
	unsigned int reservedTwo;
	unsigned int reservedThree;
	unsigned int reservedFour;
};

//*Nephalem
struct _XML_DATAWRITER_TOPIC_SET : public _DATA_WRITER_QOS
{
	bool bUseXmlTopicQos;
	//bool bUseMulticast;	
	//unsigned long ulMulticastAddress;
	//_DATA_WRITER_QOS TopicQoS;
	_XML_DATAWRITER_TOPIC_SET()
	{
		bUseXmlTopicQos = false;
	}
};

struct _XML_DATAREADER_TOPIC_SET : public _DATA_READER_QOS
{
	bool bUseMulticast;	
	unsigned int ulMulticastAddress;
	bool bUseXmlTopicQos;

	_XML_DATAREADER_TOPIC_SET()
	{
		bUseXmlTopicQos = false;
	}
};

#define  InCludeVersion  0001;







#ifndef VXWORKS
#ifndef _DDS_LIB_FILE
#ifdef _DDS_DLL_FILE
#define DDS_DLL _declspec(dllexport)
#else
#define DDS_DLL _declspec(dllimport)
#endif
#endif
#endif

#endif
