/************************************************************
** 文件名：ReturnCode.h
** Copyright (c) 2011-2012 中国船舶工业系统工程研究院
** 创建人：杨猛<635584332@qq.com>
** 日  期：2011-01-11
** 修改人：无
** 日  期：无
** 描  述：ReturnCode头文件
** 版  本：Version 0.1
**----------------------------------------------------------
************************************************************/
#ifndef _DDS_RETURNCODE_H_INCLUDED_
#define _DDS_RETURNCODE_H_INCLUDED_

typedef long _RETURNCODE_T;

//执行成功
const _RETURNCODE_T RETURNCODE_OK = 0;

/**
*/
//配置项失败
const _RETURNCODE_T RETURNCODE_CONFIG_FAILED = -101;
//Locator初始化失败（ip错误）
const _RETURNCODE_T RETURNCODE_LOCATOR_INIT_FAILED = -102;
//删除Reader时Reader不存在
const _RETURNCODE_T RETURNCODE_READER_NOT_EXIST = -103;
//删除Writer时Writer不存在
const _RETURNCODE_T RETURNCODE_WRITER_NOT_EXIST = -104;
//SEND任务创建失败
const _RETURNCODE_T RETURNCODE_SENDTASK_CREATE_FAILED = -105;
//RECEIVE任务创建失败
const _RETURNCODE_T RETURNCODE_RECEIVETASK_CREATE_FAILED = -106;
//DISPATCH任务创建失败
const _RETURNCODE_T RETURNCODE_DISPATCHTASK_CREATE_FAILED = -107;

/**
* @ Participant ReturnCode
*/
const _RETURNCODE_T RETURNCODE_PARTICIPANT_CREATE_FAILED = 2;


/**
* @ HistoryCache ReturnCode
*/
const _RETURNCODE_T RETURNCODE_CACHE_FULL = 3;
const _RETURNCODE_T RETURNCODE_CACHE_EMPTY = 4;
const _RETURNCODE_T RETURNCODE_CHANGE_RE_ADD = 5;
const _RETURNCODE_T RETURNCODE_CHANGE_NOT_EXIST = 6;
const _RETURNCODE_T RETURNCODE_CACHE_INIT_FAILED = 7;

/**
* @ ReceiveBuffer ReturnCode
*/
const _RETURNCODE_T RETURNCODE_BUFFER_EMPTY = 7;
const _RETURNCODE_T RETURNCODE_BUFFER_FULL = 8;
const _RETURNCODE_T RETURNCODE_RECVBUFFER_ERROR = 9;

/**
* @ MessageTransmitter ReturnCode
*/
const _RETURNCODE_T RETURNCODE_ADDR_RE_ADD = 9;
const _RETURNCODE_T RETURNCODE_ADDR_NOT_EXIST = 10;


/**
* @ Writer/StatefulWriter ReturnCode
*/
const _RETURNCODE_T RETURNCODE_READERPROXY_NOT_EXIST = 200;
const _RETURNCODE_T RETURNCODE_STATEFULWRITER_INIT_FAILED = 995;
const _RETURNCODE_T RETURNCODE_NO_DATA_TO_SEND = 222;

/**
* @ Reader/StatefulReader ReturnCode
*/
const _RETURNCODE_T RETURNCODE_STATEFULREADER_INIT_FAILED = 990;
const _RETURNCODE_T RETURNCODE_READER_INIT_FAILED = 989;
const _RETURNCODE_T RETURNCODE_NEW_CHANGE_FAILED = 12;
const _RETURNCODE_T RETURNCODE_DATA_MESSAGE_INVALID = 13;
const _RETURNCODE_T RETURNCODE_NO_MATCHED_WRITERPROXY = 14;
const _RETURNCODE_T RETURNCODE_HEARTBEAT_TOO_SOON = 2;
const _RETURNCODE_T RETURNCODE_CHANGE_FROM_WRITER_RE_ADD = 15;
const _RETURNCODE_T RETURNCODE_CHANGE_FROM_WRITER_NOT_EXIST = 16;
const _RETURNCODE_T RETURNCODE_CHANGE_FROM_WRITER_NOTIFY_ERROR = 17;
const _RETURNCODE_T RETURNCODE_CHANGE_FROM_WRITER_LOST_UPDATE_ERROR = 18;
const _RETURNCODE_T RETURNCODE_CHANGE_FROM_WRITER_MISSING_UPDATE_ERROR = 19;
const _RETURNCODE_T RETURNCODE_CHANGE_FROM_WRITER_RECEIVED_AGAIN = 20;
const _RETURNCODE_T RETURNCODE_CHANGE_FROM_WRITER_RECEIVED_REJECT = 21;
const _RETURNCODE_T RETURNCODE_CHANGE_FROM_WRITER_RECEIVED_SET_ERROR =22;

/**
* @ WriterProxy ReturnCode
*/
const _RETURNCODE_T RETURNCODE_WRITERPROXY_RE_ADD = 23;
const _RETURNCODE_T RETURNCODE_WRITERPROXY_NOT_EXIST = 24;

/**
* @ ReaderProxy ReturnCode
*/
const _RETURNCODE_T RETURNCODE_CHANGEFORREADER_NOT_EXIST = 1000;
const _RETURNCODE_T RETURNCODE_READERPROXY_INIT_FAILED = 10000;


//接收的Data报文不含数据
const _RETURNCODE_T RETURNCODE_DATA_EMPTY = 25;

const _RETURNCODE_T RETURNCODE_DATA_NOTIFY_FAILED = 26;


const _RETURNCODE_T RETURNCODE_REQUEST_ERROR = 27;

const _RETURNCODE_T RETURNCODE_ENDPOINT_NOT_EXIST = 28;
const _RETURNCODE_T RETURNCODE_SUBMESSAGE_INVALID = 29;

const _RETURNCODE_T RETURNCODE_ERROR = -1;
const _RETURNCODE_T RETURNCODE_ACKNACK_GET_ERROR = 30;



//
const _RETURNCODE_T RETURN_DEADLINE_MISSED = 2;


const _RETURNCODE_T RETURNCODE_CLEAN_SUCCESSFUL = 31;
const _RETURNCODE_T RETURNCODE_INITIALIZE_SUCCESSFUL = 32;
const _RETURNCODE_T RETURNCODE_DELETE_FAIL = 33;
const _RETURNCODE_T RETURNCODE_DELETE_SUCCESSFUL = 34;
const _RETURNCODE_T RETURNCODE_REGISTER_TYPE_EXISTED= 35;
const _RETURNCODE_T RETURNCODE_ADD_SUCCESSFUL= 36;
const _RETURNCODE_T RETURNCODE_REPLACE_SUCCESSFUL= 37;
const _RETURNCODE_T RETURNCODE_REPLACE_FAIL= 38;
const _RETURNCODE_T RETURNCODE_REGISTER_TYPECODE_EXISTED= 39;


/**
* @ DataReader ReturnCode
*/
const _RETURNCODE_T RETURNCODE_SET_QOS_DISCOVERY_MODIFY_FAILED= 38;
const _RETURNCODE_T RETURNCODE_SET_LISTENER_DISCOVERY_MODIFY_FAILED= 38;
const _RETURNCODE_T RETURNCODE_GET_CHANGE_FAILED= 38;
const _RETURNCODE_T RETURNCODE_ON_DATA_AVAILABLE_ERROR= 38;
const _RETURNCODE_T RETURNCODE_NO_SAMPLE= 38;
const _RETURNCODE_T RETURNCODE_ON_REQUESTED_DEADLINE_MISSED= 38;

/**
* @ DataWriter ReturnCode
*/
//const _RETURNCODE_T RETURNCODE_REMOVE_CHANGE_FAILED= 38;
//const _RETURNCODE_T RETURNCODE_ON_OFFERED_DEADLINE_MISSED= 38;
const _RETURNCODE_T RETURNCODE_NEW_CACHECHANGE_FAILED= 38;
const _RETURNCODE_T RETURNCODE_ADD_CHANGE_FAILED= 38;
const _RETURNCODE_T RETURNCODE_SEND_DATA_FAILED= 38;

/**
* @ DomainParticipantFactory ReturnCode
*/
const _RETURNCODE_T RETURNCODE_NO_DOMAINID= 38;
const _RETURNCODE_T RETURNCODE_DELETE_PARTICIPANT_FAILED= 38;
const _RETURNCODE_T RETURNCODE_NO_DOMAINPARTICIPANT= 38;



/**
* @ StringDataReader ReturnCode
*/

//const _RETURNCODE_T RETURNCODE_DELETE_SAMPLEINFO_FAILED= 38;




const _RETURNCODE_T lReturnCode_tRANSMITTERUNICAST_FAIDED = 50;

const _RETURNCODE_T RETURNCODE_SEND_FAIDED = 51;
const _RETURNCODE_T RETURNCODE_RECEIVE_ADDR_ADD_ERROR = 52;
//StringTypeSupport

const _RETURNCODE_T RETURNCODE_SOURCE_ADDR_NOT_EXIST = 53;

const _RETURNCODE_T RETURNCODE_RIGISTER_TYPE_FAILED= 38;
const _RETURNCODE_T RETURNCODE_REUSEADDR_ERROR = 50;
const _RETURNCODE_T RETURNCODE_REUSEPORT_ERROR = 51;
const _RETURNCODE_T RETURNCODE_RECEFROM_FAILED = 56;
const _RETURNCODE_T RETURNCODE_SELECT_ERROR = 57;
const _RETURNCODE_T RETURNCODE_SELECT_TIMEOUT = 58;

const _RETURNCODE_T RETURNCODE_RECEIVE_ADDR_EMPTY = 100;

const _RETURNCODE_T RETURNCODE_REQUEST_NO_LONGER_EXIST = 110;


const _RETURNCODE_T RETURNCODE_BORADCAST_ERROR = 120;


const _RETURNCODE_T RETURNCODE_REGISTER_TYPE_NULL = 130;

const _RETURNCODE_T RETURNCODE_AGENT_INIT_FAILED = 140;
const _RETURNCODE_T RETURNCODE_REGISTER_TYPE_NOT_EXSIT = 150;
const _RETURNCODE_T RETURNCODE_DOMAIN_PARTICIPANT_CREATE_FAILED = 160;

const _RETURNCODE_T RETURNCODE_DOMAIN_NOT_INIT = 500;
const _RETURNCODE_T RETURNCODE_DOMAIN_INIT_FAILED = 600;


const _RETURNCODE_T RETURNCODE_SENDPARTICIPANTDATA_FAILED = 800;

const _RETURNCODE_T RETURNCODE_PARTICIPANT_LISTENER_ERROR = 900;
const _RETURNCODE_T RETURNCODE_CHECKTASK_CREATE_FAILED = 1000;

const _RETURNCODE_T RETURNCODE_ACK_ENCAPSULATE_ERROR = 5436;
const _RETURNCODE_T RETURNCODE_ACK_LOCATOR_ERROR = 554;
const _RETURNCODE_T RETURNCODE_DATA_ENCAPSULATE_ERROR = 567;
const _RETURNCODE_T RETURNCODE_DATA_LOCATOR_ERROR = 645;
const _RETURNCODE_T RETURNCODE_CREATE_DATAWRITER_FAILED = 999;
const _RETURNCODE_T RETURNCODE_CREATE_DATAREADER_FAILED = 998;

const _RETURNCODE_T RETURNCODE_DELETEREQUEST_NOT_EXIST = 997;



const _RETURNCODE_T RETURNCODE_HEARTBEAT_GET_ERROR = 900;

const _RETURNCODE_T RETURNCODE_DATA_GET_ERROR = 143;


const _RETURNCODE_T RETURNCODE_PARTICIPANT_DATAMANAGER_INIT_FAILED = 953;
const _RETURNCODE_T RETURNCODE_PUBLICATIONS_DATAMANAGER_INIT_FAILED = 957;
const _RETURNCODE_T RETURNCODE_SUBSCRIPTIONS_DATAMANAGER_INIT_FAILED = 956;


const _RETURNCODE_T RETURNCODE_APPSET_FAILED = 1111;

const _RETURNCODE_T RETURNCODE_APP_NOTSET = 1241;

const _RETURNCODE_T RETURNCODE_RECORDSEND_ERROR = 1241;

const _RETURNCODE_T RETURNCODE_DOMAINPARTICIPANT_BUILTINENDPOINT_INIT_FAILED = 12412;

const _RETURNCODE_T RETURNCODE_DISCOVERY_PARTICIPANTDATAWRITER_CREATE_FAILED = 242;
const _RETURNCODE_T RETURNCODE_DISCOVERY_PUBLICATIONSDATAWRITER_CREATE_FAILED = 4124;
const _RETURNCODE_T RETURNCODE_DISCOVERY_SUBSCRIPTIONSDATAWRITER_CREATE_FAILED = 214;
const _RETURNCODE_T RETURNCODE_DISCOVERY_PARTICIPANTDATAREADER_CREATE_FAILED = 24;
const _RETURNCODE_T RETURNCODE_DISCOVERY_PUBLICATIONSDATAREADER_CREATE_FAILED = 241;
const _RETURNCODE_T RETURNCODE_DISCOVERY_SUBSCRIPTIONSDATAREADER_CREATE_FAILED = 215;

/**
* @ KeyedStringDataWriter ReturnCode
*/
const _RETURNCODE_T RETURNCODE_BAD_PARAMETER = 201;
const _RETURNCODE_T RETURNCODE_PRECONDITION_NOT_MET = 202;
const _RETURNCODE_T RETURNCODE_NO_DATA = 203;

/**
* @ Multicast ReturnCode
*/
const _RETURNCODE_T RETURNCODE_MULTIADDRESS_ERROR = 1250;
const _RETURNCODE_T RETURNCODE_MULTICAST_ERROR = 1251;
const _RETURNCODE_T RETURNCODE_RECEIVE_MULTIADDR_ADD_ERROR = 1252;
const _RETURNCODE_T RETURNCODE_MULTIGROUP_QUIT_ERROR = 1253;

/**
* @ Multicast ReturnCode
*/
const _RETURNCODE_T RETURNCODE_FRAGMISSING = 1260;

/**
* @ Delete DataWriter/DataReader ReturnCode
*/
const _RETURNCODE_T RETURNCODE_DELETEDATAWRITER_OK = 1270;
const _RETURNCODE_T RETURNCODE_DELETEDATAREADER_OK = 1271;

#endif
